'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: November 23, 2003
'=============================================


''' <summary>
''' Contains types relates to animation.
''' </summary>
'Namespace Animation

''' <summary>
''' Contais a collection of Track types.
''' </summary>
Friend Class Animation 'Controller
    ' Inherits Hashtable
    Implements IDisposable

    Protected Friend mblnEnabled As Boolean = True
    Protected Friend mobjTracks As New Collections.Hashtable()

    ''' <summary>
    ''' Gets/sets weather this track is enabled or not.
    ''' </summary>
    ''' <returns>Returns True is thrack is enabled.</returns>
    Public Overridable Property Enabled() As Boolean
        Get
            Return mblnEnabled
        End Get
        Set(ByVal Value As Boolean)
            mblnEnabled = Value
        End Set
    End Property

    '''' <summary>
    '''' Swaps the location of two objects in the collection.
    '''' </summary>
    '''' <param name="Item1">The first reference to a Track type previously added to the collection.</param>
    '''' <param name="Item2">The second reference to a Track type previously added to the collection.</param>
    'Public Sub Swap(ByVal Item1 As Track, ByVal Item2 As Track)
    '    Dim Index1, Index2 As Integer

    '    Index1 = Me.IndexOf(Item1)
    '    Index2 = Me.IndexOf(Item2)

    '    ' do err chech
    '    If Index1 < 0 Or Index1 > Me.Count - 1 Then Throw New ArgumentOutOfRangeException("Item1", "The item was not previosly added to this collection.")
    '    If Index2 < 0 Or Index2 > Me.Count - 1 Then Throw New ArgumentOutOfRangeException("Item2", "The item was not previosly added to this collection.")
    '    ' dont need to do anything
    '    If Index1 = Index2 Then Exit Sub

    '    Swap(Index1, Index2)
    'End Sub

    '''' <summary>
    '''' Swaps the location of two items in the collection.
    '''' </summary>
    '''' <param name="Index1">The index of the first item.</param>
    '''' <param name="Index2">The index of the second item.</param>
    'Public Sub Swap(ByVal Index1 As Integer, ByVal Index2 As Integer)
    '    Dim intFirst, intLast As Integer
    '    Dim objFirst, objLast As Track

    '    ' do err chech
    '    If Index1 < 0 Or Index1 > Me.Count - 1 Then Throw New ArgumentOutOfRangeException("Index1")
    '    If Index2 < 0 Or Index2 > Me.Count - 1 Then Throw New ArgumentOutOfRangeException("Index2")
    '    ' dont need to do anything
    '    If Index1 = Index2 Then Exit Sub

    '    intFirst = CType(IIf(Index1 < Index2, Index1, Index2), Integer)
    '    intLast = CType(IIf(Index1 > Index2, Index1, Index2), Integer)

    '    ' store items
    '    objFirst = Me(intFirst)
    '    objLast = Me(intLast)

    '    ' remove from list
    '    Me.Remove(intLast)
    '    Me.Remove(intFirst)
    '    ' reinsert
    '    Me.Insert(intFirst, objFirst)
    '    Me.Insert(intLast, objLast)
    'End Sub

    ''' <summary>
    ''' Disposes of all items in the collection by calling the Clear method.
    ''' </summary>
    Public Sub Dispose() Implements System.IDisposable.Dispose
        mobjTracks.Clear()
        mobjTracks = Nothing
    End Sub

    '''' <summary>
    '''' Adds a Track type to the collection.
    '''' </summary>
    '''' <param name="Item">A reference to a Track type.</param>
    '''' <returns>Returns the index that the item was added to.</returns>
    'Public Overrides Function Add(ByVal Name As String, ByVal Item As Track) As Boolean
    '    If mobjTracks.ContainsKey(Name) Then Return False
    '    mobjTracks.Add(Name, Item)
    '    Return True
    'End Function

    '''' <summary>
    '''' Returns the index of a Track type previously added to the collection.
    '''' </summary>
    '''' <param name="Item">A reference to a Track type that was previously added.</param>
    'Public Function IndexOf(ByVal Item As Track) As Integer
    '    Return Me.InnerList.IndexOf(Item)
    'End Function

    '''' <summary>
    '''' Inserts a Track type into the collection.
    '''' </summary>
    '''' <param name="Index">The index of the item to be retrieved.</param>
    '''' <param name="Item">A reference to a Track type.</param>
    'Public Sub Insert(ByVal Index As Integer, ByVal Item As Track)
    '    Me.InnerList.Insert(Index, Item)
    'End Sub

    '''' <summary>
    '''' Gets/Sets a item in the collection.
    '''' </summary>
    '''' <param name="Index">The index of the item to be retrieved.</param>
    '''' <returns>Returns a reference to a Track type.</returns>
    'Default Public Property Item(ByVal Index As Integer) As Track
    '    Get
    '        Return CType(Me.InnerList(Index), Track)
    '    End Get
    '    Set(ByVal Value As Track)
    '        Me.InnerList(Index) = Value
    '    End Set
    'End Property

    '''' <summary>
    '''' Removes an item.
    '''' </summary>
    '''' <param name="Item">A reference to a Track type previously added to the collection.</param>
    'Public Sub Remove(ByVal Item As Track)
    '    Me.InnerList.Remove(Item)
    'End Sub

    '''' <summary>
    '''' Removes an item.
    '''' </summary>
    '''' <param name="Index">The index of the item to be removed.</param>
    'Public Sub Remove(ByVal Index As Integer)
    '    Me.InnerList.RemoveAt(Index)
    'End Sub

    '''' <summary>
    '''' Removes a number of items.
    '''' </summary>
    '''' <param name="Index">The index of the first item to be removed.</param>
    '''' <param name="Count">The number of items to removed.</param>
    'Public Sub Remove(ByVal Index As Integer, ByVal Count As Integer)
    '    Me.InnerList.RemoveRange(Index, Count)
    'End Sub
End Class
'End Namespace

