Public NotInheritable Class Animation
    Public Enum Interpolation
        Frames = 0
        Linear = 1
    End Enum

    Friend Structure Key
        Public Value As Single
        Public Time As Long
    End Structure

    Friend Structure Track
        Public Keys() As Key
        Public CurrentKey As Integer
        Public BaseTime As Long
        Public Name As String
        Public Enabled As Boolean
    End Structure

    Friend LastTime As Long
    Public Enabled As Boolean = True
    Friend Tracks() As Track = Nothing
    ' Friend TrackNames() As String
    ' Friend TrackEnabled() As Boolean
    Friend mintTrackCount As Integer = 0
    ' Friend mintLength As Integer = 0
    ' Friend mintCurrentFrame As Integer = -1
    Public PlayStyle As AnimationPlayStyle = AnimationPlayStyle.Loop
    ' Protected Friend mintFramesPerSecond As Integer = 30
    Public InterpolationMode As Interpolation = InterpolationMode.Linear


    'Public Property CurrentFrame() As Integer
    '    Get
    '        Return mintCurrentFrame
    '    End Get
    '    Set(ByVal Value As Integer)
    '        If Value > 0 And Value <= Me.mintLength - 1 And Me.mintTrackCount > 0 Then mintCurrentFrame = Value
    '    End Set
    'End Property

    'Public Property FramesPerSecond() As Integer
    '    Get
    '        Return mintFramesPerSecond
    '    End Get
    '    Set(ByVal Value As Integer)
    '        mintFramesPerSecond = Value
    '        If mintFramesPerSecond < 0 Then mintFramesPerSecond = 0
    '    End Set
    'End Property

    'Public Function GetValue(ByVal Track As String, ByRef Value As Single) As Boolean
    '    Dim Index As Integer = 0
    '    While Index <= Me.mintTrackCount - 1
    '        If Me.TrackNames(Index) = Track Then
    '            Value = Me.Tracks(Index, Me.mintCurrentFrame)
    '            Return True
    '        End If
    '        Index += 1
    '    End While

    '    Return False
    'End Function

    'Public Function GetValue(ByVal Track As Integer, ByRef Value As Single) As Boolean
    '    If Track < 0 Then Return False
    '    If Track > Me.mintTrackCount - 1 Then Return False
    '    Value = Me.Tracks(Track, Me.mintCurrentFrame)
    '    Return True
    'End Function

    'Public Function SetValue(ByVal Track As String, ByVal Frame As Integer, ByVal Value As Single) As Boolean
    '    Dim Index As Integer = 0
    '    If Frame < 0 Then Return False
    '    If Frame > Me.mintLength - 1 Then Return False
    '    While Index <= Me.mintTrackCount - 1
    '        If Me.TrackNames(Index) = Track Then
    '            Me.Tracks(Index, Frame) = Value
    '            Return True
    '        End If
    '        Index += 1
    '    End While

    '    Return False
    'End Function

    'Public Function SetValue(ByVal Track As Integer, ByVal Frame As Integer, ByVal Value As Single) As Boolean
    '    If Track < 0 Then Return False
    '    If Track > Me.mintTrackCount - 1 Then Return False
    '    If Frame < 0 Then Return False
    '    If Frame > Me.mintLength - 1 Then Return False
    '    Me.Tracks(Track, Frame) = Value
    '    Return True
    'End Function

    'Public Sub Update(ByVal CurrentTime As Long, ByVal Frequency As Long)
    '    If Me.Enabled = False Then Exit Sub
    '    If Me.mintTrackCount = 0 Then Exit Sub
    '    If Me.mintLength = 0 Then Exit Sub
    '    If CurrentTime > Me.LastTime + (Frequency \ Me.mintFramesPerSecond) Then
    '        Me.mintCurrentFrame += 1
    '        If Me.mintLength > 0 And Me.mintCurrentFrame > Me.mintLength - 1 Then
    '            If Me.PlayStyle = AnimationPlayStyle.Loop Then
    '                mintCurrentFrame = 0
    '            Else
    '                mintCurrentFrame = Me.mintLength - 1
    '            End If
    '        End If
    '        Me.LastTime = CurrentTime
    '    End If
    'End Sub

    Public Sub Update(ByVal CurrentTime As Long, ByVal Frequency As Long)
        If Me.Enabled = False Then Exit Sub
        If Me.mintTrackCount = 0 Then Exit Sub

        Dim TrackIndex, KeyIndex As Integer
        For TrackIndex = 0 To Tracks.Length - 1
            If Tracks(TrackIndex).Enabled Then
                Dim KT As Integer
                KT = 0
                ' while current time is greater then 
                While CurrentTime > Tracks(TrackIndex).BaseTime + Tracks(TrackIndex).Keys(Tracks(TrackIndex).CurrentKey).Time
                    If Me.PlayStyle = AnimationPlayStyle.PlayOnce Then

                    End If
                End While

                For KeyIndex = 0 To Tracks(TrackIndex).Keys.Length - 1

                Next
            End If
        Next
        If CurrentTime > Me.LastTime + (Frequency \ Me.mintFramesPerSecond) Then
            Me.mintCurrentFrame += 1
            If Me.mintLength > 0 And Me.mintCurrentFrame > Me.mintLength - 1 Then
                If Me.PlayStyle = AnimationPlayStyle.Loop Then
                    mintCurrentFrame = 0
                Else
                    mintCurrentFrame = Me.mintLength - 1
                End If
            End If
            Me.LastTime = CurrentTime
        End If
    End Sub

    Public Property TrackCount() As Integer
        Get
            Return mintTrackCount
        End Get
        Set(ByVal Value As Integer)
            If Value <= 0 Then
                Erase Me.Tracks
                ' Erase Me.TrackNames
                ' Erase Me.TrackEnabled
                ' Me.mintCurrentFrame = -1
                ' Me.mintLength = 0
            Else
                Me.mintTrackCount = Value
                'If Me.mintLength = 0 Then
                ReDim Preserve Me.Tracks(Me.mintTrackCount - 1) ', 0)
                ' Else
                '    ReDim Preserve Me.Tracks(Me.mintTrackCount - 1) ', Me.mintLength - 1)
                'End If
                ' ReDim Preserve Me.TrackNames(Me.mintTrackCount - 1)
                '  ReDim Preserve Me.TrackEnabled(Me.mintTrackCount - 1)
            End If
        End Set
    End Property

    'Public Property Length() As Integer
    '    Get
    '        Return mintLength
    '    End Get
    '    Set(ByVal Value As Integer)
    '        If Value <= 0 Then
    '            Value = 0
    '            Me.mintCurrentFrame = -1
    '            ReDim Preserve Me.Tracks(Me.mintTrackCount - 1) ', 0)
    '        Else
    '            Me.mintLength = Value
    '            If mintCurrentFrame > Me.mintLength - 1 Then mintCurrentFrame = Me.mintLength - 1
    '            ReDim Preserve Me.Tracks(Me.mintTrackCount - 1, Me.mintLength - 1)
    '            ReDim Preserve Me.TrackNames(Me.mintTrackCount - 1)
    '            ReDim Preserve Me.TrackEnabled(Me.mintTrackCount - 1)
    '        End If
    '    End Set
    'End Property
End Class