﻿Public Module Cameras
    'Friend Class CameraTarget
    '    Inherits LockOnTargetPosition

    '    Public Parent As Camera

    '    Public Sub New(ByVal Parent As Camera)
    '        Me.New()
    '        Me.Parent = Parent
    '    End Sub

    '    Public Sub New()
    '        MyBase.new()
    '    End Sub
    'End Class

    Friend Class Camera
        'Implements ILockOnTarget

        'Public mobjPosition As ILockOnTarget = New LockOnTargetPosition()
        'Public mobjTarget As ILockOnTarget = New CameraTarget()
        'Public mobjOrientation As ILockOnTarget = New LockOnTargetPosition()
        Public PositionX, PositionY, PositionZ As Single
        Public LookAtX, LookAtY, LookAtZ As Single
        Public OrientationX, OrientationY, OrientationZ As Single
        Public FieldOfView As Single = Direct3D.Geometry.DegreeToRadian(90)
        Public NearPlane As Single = 0
        Public FarPlane As Single = 10000
        Private mstrName As String


        Public Property Name() As String
            Get
                Return mstrName
            End Get
            Set(ByVal value As String)
                If value Is Nothing Then Throw New ArgumentNullException("Value")
                If value.Trim = String.Empty Then Throw New ArgumentNullException("Value")
                If mobjCameras Is Nothing = False Then
                    If mstrName Is Nothing = False Then
                        If mobjCameras.ContainsKey(mstrName) Then mobjCameras.Remove(mstrName)
                    End If
                End If
                mstrName = value
                If mobjCameras Is Nothing = False Then
                    mobjCameras.Add(mstrName, Me)
                End If
            End Set
        End Property

        Public Property Orientation() As Vector3
            Get
                Return New Vector3(OrientationX, OrientationY, OrientationZ) ' mobjOrientation.TargetPosition
            End Get
            Set(ByVal value As Vector3)
                OrientationX = value.X
                OrientationY = value.Y
                OrientationZ = value.Z
                ' mobjOrientation.TargetPosition = value
            End Set
        End Property

        'Public Property TargetOrientation() As ILockOnTarget
        '    Get
        '        Return mobjOrientation
        '    End Get
        '    Set(ByVal value As ILockOnTarget)
        '        mobjOrientation = value
        '        If mobjOrientation Is Nothing Then mobjOrientation = New LockOnTargetPosition()
        '    End Set
        'End Property

        Public Property LookAt() As Vector3
            Get
                Return New Vector3(LookAtX, LookAtY, LookAtZ) 'mobjTarget.TargetPosition
            End Get
            Set(ByVal value As Vector3)
                LookAtX = value.X
                LookAtY = value.Y
                LookAtZ = value.Z
                '  mobjTarget.TargetPosition = value
            End Set
        End Property

        'Public Property TargetLookAt() As ILockOnTarget
        '    Get
        '        Return mobjTarget
        '    End Get
        '    Set(ByVal value As ILockOnTarget)
        '        mobjTarget = value
        '        If mobjTarget Is Nothing Then mobjTarget = New CameraTarget(Me)
        '    End Set
        'End Property

        Public Property Position() As Microsoft.DirectX.Vector3 'Implements ILockOnTarget.TargetPosition
            Get
                Return New Vector3(PositionX, PositionY, PositionZ) 'Me.mobjPosition.TargetPosition
            End Get
            Set(ByVal value As Microsoft.DirectX.Vector3)
                PositionX = value.X
                PositionY = value.Y
                PositionZ = value.Z
                '  Me.mobjPosition.TargetPosition = value
            End Set
        End Property

        'Public Property TargetPosition() As ILockOnTarget
        '    Get
        '        Return mobjPosition
        '    End Get
        '    Set(ByVal value As ILockOnTarget)
        '        mobjPosition = value
        '        If mobjPosition Is Nothing Then mobjPosition = New LockOnTargetPosition()
        '    End Set
        'End Property
    End Class

    Friend mobjCameras As New Collections.Hashtable() '.Collection.(Of Camera)
    Friend mstrCurrentCamera As String = ""
    Public Const CURRENTCAMERA As String = "{937909CB-A866-4cf4-BB8E-2A57304DB9E6}"

    'Public Enum CameraData As Integer
    '    Position = 1
    '    LookAt = 2
    '    Orientation = 4
    '    FieldOfView = 8
    'End Enum

    Public Function ApplyCamera() As Boolean
        ApplyCamera(mstrCurrentCamera)
    End Function

    Public Function ApplyCamera(ByVal Name As String) As Boolean
        If mblnHasBeenInit = False Then Return False
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) = False Then Return False
        Dim Cam As Camera = DirectCast(mobjCameras(Name), Camera)
        mobjDevice.Transform.View = Matrix.LookAtLH(Cam.Position, Cam.LookAt, Cam.Orientation)
        Dim VP As Viewport = DirectCast(mobjViewports(mstrCurrentViewport), Viewport)
        Dim Aspect As Single = CSng(VP.Viewport.Width / VP.Viewport.Height)
        mobjDevice.Transform.Projection = Matrix.PerspectiveFovLH(Cam.FieldOfView, Aspect, Cam.NearPlane, Cam.FarPlane)
        Return True
    End Function

    Public Function ChangeCameraName(ByRef Name As String, ByVal Value As String) As Boolean
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) Then Return False
        If mobjCameras.ContainsKey(Value) Then Return False
        Dim Item As Camera
        Item = DirectCast(mobjCameras(Name), Camera)
        mobjCameras.Remove(Name)
        mobjCameras.Add(Value, Item)

        Return True
    End Function

    Public Function GetCameraNames(ByRef Names() As String) As Boolean
        Erase Names
        ReDim Names(mobjCameras.Count - 1)
        mobjCameras.Keys.CopyTo(Names, 0)

        Return True
    End Function

    Public Sub RemoveAllCameras()
        mobjCameras.Clear()
    End Sub

    Public Function GetNumberOfCameras() As Integer
        Return mobjCameras.Count
    End Function

    Public Function GetCurrentCamera() As String
        Return mstrCurrentCamera
    End Function

    Public Function SetCurrentCamera(ByVal Name As String, Optional ByVal ApplyCamera As Boolean = True) As Boolean
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) = False Then Return False
        mstrCurrentCamera = Name
        Cameras.ApplyCamera(Name)
        Return True
    End Function

    Public Function RemoveCamera(ByVal Name As String) As Boolean
        If mobjCameras.ContainsKey(Name) = False Then Return False
        mobjCameras.Remove(Name)
        Return True
    End Function

    Public Function AddCamera(ByVal Name As String, ByVal X As Single, ByVal Y As Single, ByVal Z As Single, _
                              ByVal LookAtX As Single, ByVal LookAtY As Single, ByVal LookAtZ As Single, _
                              ByVal OrientationX As Single, ByVal OrientationY As Single, ByVal OrientationZ As Single, ByVal FOV As Single, _
                              ByVal NearPlane As Single, ByVal FarPlane As Single, Optional ByVal SetAsCurrent As Boolean = False) As Boolean
        Return AddCamera(Name, New Vector3(X, Y, Z), New Vector3(LookAtX, LookAtY, LookAtZ), New Vector3(OrientationX, OrientationY, OrientationZ), _
                         FOV, NearPlane, FarPlane, SetAsCurrent)
    End Function

    Public Function AddCamera(ByVal Name As String, ByVal Position As Vector3, ByVal LookAt As Vector3, ByVal Orientation As Vector3, ByVal FOV As Single, _
       ByVal NearPlane As Single, ByVal FarPlane As Single, Optional ByVal SetAsCurrent As Boolean = False) As Boolean
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) Then Return False
        Dim Cam As New Camera()
        Cam.Position = Position
        Cam.LookAt = LookAt
        Cam.Orientation = Orientation
        Cam.FieldOfView = FOV
        Cam.NearPlane = NearPlane
        Cam.FarPlane = FarPlane
        mobjCameras.Add(Name, Cam)
        If SetAsCurrent Then mstrCurrentCamera = Name 'mobjCameras.IndexOf(Cam)
        Return True ' mobjCameras.IndexOf(Cam)
    End Function

    'Public Function GetCamera() As Camera
    '    Return GetCamera(mintCurrentCamera)
    'End Function

    'Public Function GetCamera(ByVal Index As Integer) As Camera
    '    If Index < 0 Then Return Nothing
    '    If Index > mobjCameras.Count - 1 Then Return Nothing
    '    Return DirectCast(mobjCameras(Index), Camera)
    'End Function


    Public Function SetCameraOrientation(ByVal Value As Vector3) As Boolean
        Return SetCameraOrientation(mstrCurrentCamera, Value.X, Value.Y, Value.Z)
    End Function

    Public Function SetCameraOrientation(ByVal Name As String, ByVal Value As Vector3) As Boolean
        Return SetCameraOrientation(Name, Value.X, Value.Y, Value.Z)
    End Function

    Public Function GetCameraOrientation(ByRef Value As Vector3) As Boolean
        Return GetCameraOrientation(Value.X, Value.Y, Value.Z)
    End Function

    Public Function GetCameraOrientation(ByVal Name As String, ByRef Value As Vector3) As Boolean
        Return GetCameraOrientation(Name, Value.X, Value.Y, Value.Z)
    End Function

    Public Function SetCameraLookAt(ByVal Value As Vector3) As Boolean
        Return SetCameraLookAt(mstrCurrentCamera, Value.X, Value.Y, Value.Z)
    End Function

    Public Function SetCameraLookAt(ByVal Name As String, ByVal Value As Vector3) As Boolean
        Return SetCameraLookAt(Name, Value.X, Value.Y, Value.Z)
    End Function

    Public Function GetCameraLookAt(ByRef Value As Vector3) As Boolean
        Return GetCameraLookAt(Value.X, Value.Y, Value.Z)
    End Function

    Public Function GetCameraLookAt(ByVal Name As String, ByRef Value As Vector3) As Boolean
        Return GetCameraLookAt(Name, Value.X, Value.Y, Value.Z)
    End Function

    Public Function SetCameraPosition(ByVal Value As Vector3) As Boolean
        Return SetCameraPosition(mstrCurrentCamera, Value.X, Value.Y, Value.Z)
    End Function

    Public Function SetCameraPosition(ByVal Name As String, ByVal Value As Vector3) As Boolean
        Return SetCameraPosition(Name, Value.X, Value.Y, Value.Z)
    End Function

    Public Function GetCameraPosition(ByRef Value As Vector3) As Boolean
        Return GetCameraPosition(mstrCurrentCamera, Value.X, Value.Y, Value.Z)
    End Function

    Public Function GetCameraPosition(ByVal Name As String, ByRef Value As Vector3) As Boolean
        Return GetCameraPosition(Name, Value.X, Value.Y, Value.Z)
    End Function

    Public Function SetCameraOrientation(ByVal X As Single, ByVal Y As Single, ByVal Z As Single) As Boolean
        Return SetCameraOrientation(mstrCurrentCamera, X, Y, Z)
    End Function

    Public Function SetCameraOrientation(ByVal Name As String, ByVal X As Single, ByVal Y As Single, ByVal Z As Single) As Boolean
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) = False Then Return False
        DirectCast(mobjCameras(Name), Camera).Orientation = New Vector3(X, Y, Z)
        Return True
    End Function

    Public Function GetCameraOrientation(ByRef X As Single, ByRef Y As Single, ByRef Z As Single) As Boolean
        Return GetCameraOrientation(mstrCurrentCamera, X, Y, Z)
    End Function

    Public Function GetCameraOrientation(ByVal Name As String, ByRef X As Single, ByRef Y As Single, ByRef Z As Single) As Boolean
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) = False Then Return False
        With DirectCast(mobjCameras(Name), Camera).Orientation
            X = .X
            Y = .Y
            Z = .Z
        End With
        Return True
    End Function

    Public Function SetCameraLookAt(ByVal X As Single, ByVal Y As Single, ByVal Z As Single) As Boolean
        Return GetCameraLookAt(mstrCurrentCamera, X, Y, Z)
    End Function

    Public Function SetCameraLookAt(ByVal Name As String, ByVal X As Single, ByVal Y As Single, ByVal Z As Single) As Boolean
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) = False Then Return False
        DirectCast(mobjCameras(Name), Camera).LookAt = New Vector3(X, Y, Z)
        Return True
    End Function

    Public Function GetCameraLookAt(ByRef X As Single, ByRef Y As Single, ByRef Z As Single) As Boolean
        Return GetCameraLookAt(mstrCurrentCamera, X, Y, Z)
    End Function

    Public Function GetCameraLookAt(ByVal Name As String, ByRef X As Single, ByRef Y As Single, ByRef Z As Single) As Boolean
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) = False Then Return False
        With DirectCast(mobjCameras(Name), Camera).LookAt
            X = .X
            Y = .Y
            Z = .Z
        End With
        Return True
    End Function

    Public Function SetCameraPosition(ByVal X As Single, ByVal Y As Single, ByVal Z As Single) As Boolean
        Return GetCameraPosition(mstrCurrentCamera, X, Y, Z)
    End Function

    Public Function SetCameraPosition(ByVal Name As String, ByVal X As Single, ByVal Y As Single, ByVal Z As Single) As Boolean
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) = False Then Return False
        DirectCast(mobjCameras(Name), Camera).Position = New Vector3(X, Y, Z)
        Return True
    End Function

    Public Function GetCameraPosition(ByRef X As Single, ByRef Y As Single, ByRef Z As Single) As Boolean
        Return GetCameraPosition(mstrCurrentCamera, X, Y, Z)
    End Function

    Public Function GetCameraPosition(ByVal Name As String, ByRef X As Single, ByRef Y As Single, ByRef Z As Single) As Boolean
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) = False Then Return False
        With DirectCast(mobjCameras(Name), Camera).Position
            X = .X
            Y = .Y
            Z = .Z
        End With
        Return True
    End Function

    Public Function SetCameraFieldOfView(ByVal Value As Single) As Boolean
        Return SetCameraFieldOfView(mstrCurrentCamera, Value)
    End Function

    Public Function SetCameraFieldOfView(ByVal Name As String, ByVal Value As Single) As Boolean
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) = False Then Return False
        DirectCast(mobjCameras(Name), Camera).FieldOfView = Value
        Return True
    End Function

    Public Function GetCameraFieldOfView(ByRef Value As Single) As Boolean
        Return GetCameraFieldOfView(mstrCurrentCamera, Value)
    End Function

    Public Function GetCameraFieldOfView(ByVal Name As String, ByRef Value As Single) As Boolean
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) = False Then Return False
        Value = DirectCast(mobjCameras(Name), Camera).FieldOfView
        Return True
    End Function

    Public Function SetCameraNearPlane(ByVal Value As Single) As Boolean
        Return SetCameraNearPlane(mstrCurrentCamera, Value)
    End Function

    Public Function SetCameraNearPlane(ByVal Name As String, ByVal Value As Single) As Boolean
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) = False Then Return False
        DirectCast(mobjCameras(Name), Camera).NearPlane = Value
        Return True
    End Function

    Public Function GetCameraNearPlane(ByRef Value As Single) As Boolean
        Return GetCameraNearPlane(mstrCurrentCamera, Value)
    End Function

    Public Function GetCameraNearPlane(ByVal Name As String, ByRef Value As Single) As Boolean
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) = False Then Return False
        Value = DirectCast(mobjCameras(Name), Camera).NearPlane
        Return True
    End Function

    Public Function SetCameraFarPlane(ByVal Value As Single) As Boolean
        Return SetCameraFarPlane(mstrCurrentCamera, Value)
    End Function

    Public Function SetCameraFarPlane(ByVal Name As String, ByVal Value As Single) As Boolean
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) = False Then Return False
        DirectCast(mobjCameras(Name), Camera).FarPlane = Value
        Return True
    End Function

    Public Function GetCameraFarPlane(ByRef Value As Single) As Boolean
        Return GetCameraFarPlane(mstrCurrentCamera, Value)
    End Function

    Public Function GetCameraFarPlane(ByVal Name As String, ByRef Value As Single) As Boolean
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) = False Then Return False
        Value = DirectCast(mobjCameras(Name), Camera).FarPlane
        Return True
    End Function

    Public Function RotateCamera(ByVal Yaw As Single, ByVal Pitch As Single, ByVal Roll As Single) As Boolean
        Return RotateCamera(mstrCurrentCamera, Yaw, Pitch, Roll)
    End Function

    Public Function RotateCamera(ByVal Name As String, ByVal Yaw As Single, ByVal Pitch As Single, ByVal Roll As Single, _
    Optional ByVal Absolute As Boolean = True) As Boolean
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) = False Then Return False
        With DirectCast(mobjCameras(Name), Camera)
            Dim Pos As Vector3
            ' .LookAt = New Vector3(Math.Abs(.PositionX - .LookAtX), Math.Abs(.PositionY - .LookAtY), Math.Abs(.PositionZ - .LookAtZ))
            If Absolute Then
                .LookAt = Vector3.Add(.Position, New Vector3(0, 0, 1))
                .LookAt = RotateAroundAxis(.Position, .LookAt, New Vector3(Yaw, Pitch, Roll))
            Else
                .LookAt = RotateAroundAxis(.Position, .LookAt, New Vector3(Yaw, Pitch, Roll))
            End If
            'Dim q As Quaternion
            'q = 
            'Dim M As Matrix
            ' M = Matrix.RotationQuaternion(q)
            '.LookAt = RotateAroundAxis(.Position, .LookAt, Quaternion.RotationYawPitchRoll(Yaw, Pitch, Roll), True)

        End With
        Return True
    End Function

    Public Function PanCameraVertically(ByVal Distance As Single) As Boolean
        Return PanCameraVertically(mstrCurrentCamera, Distance)
    End Function

    Public Function PanCameraVertically(ByVal Name As String, ByVal Distance As Single) As Boolean
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) = False Then Return False
        With DirectCast(mobjCameras(Name), Camera)
            Dim vStrafe As Vector3 = .Orientation
            vStrafe.Multiply(Distance)
            .Position = Vector3.Add(vStrafe, .LookAt)
            .LookAt = Vector3.Add(vStrafe, .LookAt)
        End With
        Return True
    End Function

    Public Function PanCameraHorizontally(ByVal Distance As Single) As Boolean
        Return PanCameraHorizontally(mstrCurrentCamera, Distance)
    End Function

    Public Function PanCameraHorizontally(ByVal Name As String, ByVal Distance As Single) As Boolean
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) = False Then Return False
        With DirectCast(mobjCameras(Name), Camera)
            Dim vStrafe As Vector3 = Vector3.Cross(Vector3.Subtract(.LookAt, .Position), .Orientation)
            vStrafe.Multiply(Distance)
            .Position = Vector3.Add(.Position, vStrafe)
            .LookAt = Vector3.Add(vStrafe, .LookAt)
        End With
        Return True
    End Function

    Public Function MoveCameraBackward(ByVal Distance As Single) As Boolean
        Return MoveCameraBackward(mstrCurrentCamera, Distance)
    End Function

    Public Function MoveCameraBackward(ByVal Name As String, ByVal Distance As Single) As Boolean
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) = False Then Return False
        With DirectCast(mobjCameras(Name), Camera)
            Dim V As Vector3
            V = Vector3.Subtract(.Position, .LookAt) 'Calculate next step.
            'V = Vector3.Multiply(V, Distance)                   'Multiply Vector.
            ' V = Vector3.Subtract(V, New Vector3(Distance, Distance, Distance))
            V = Vector3.Multiply(V, Distance - V.Length)
            .Position = Vector3.Add(.Position, V)    'Camera take actual step backward.
            .LookAt = Vector3.Add(.LookAt, V)        'Lense take step backward also.
        End With
        Return True
    End Function

    Public Function MoveCameraForward(ByVal Distance As Single) As Boolean
        Return MoveCameraForward(mstrCurrentCamera, Distance)
    End Function

    Public Function MoveCameraForward(ByVal Name As String, ByVal Distance As Single) As Boolean
        If Name = CURRENTCAMERA Then Name = mstrCurrentViewport
        If mobjCameras.ContainsKey(Name) = False Then Return False
        With DirectCast(mobjCameras(Name), Camera)
            Dim V As Vector3
            V = Vector3.Subtract(.Position, .LookAt)
            ' V = New Vector3(Math.Abs(.PositionX - .LookAtX), Math.Abs(.PositionY - .LookAtY), Math.Abs(.PositionZ - .LookAtZ))
            V = Vector3.Multiply(V, Distance - V.Length)
            'v.Length 
            .Position = Vector3.Subtract(.Position, V)
            .LookAt = Vector3.Subtract(.LookAt, V)

            ' V = Vector3.Subtract(.Position, .LookAt)   'Calculate next step.
            ' V = Vector3.Multiply(V, Distance)                   'Multiply Vector.
            '.Position = Vector3.Subtract(.Position, V) 'Camera take actual step forward.
            ' .LookAt = Vector3.Subtract(.LookAt, V)     'Lens take step forward also.
        End With
        Return True
    End Function
End Module
