'Created by: X
'Copyright: Created by: X
'Web: http://www.createdbyx.com/
'Date: May 16, 2004
'=============================================
Imports Microsoft.DirectX.DirectInput.CooperativeLevelFlags
Imports Microsoft.DirectX.Direct3D.Geometry

Public Class Blastroidz
    Inherits DXTTesterExt.BaseExample
    Implements DXTTesterExt.IExample


    Private Blocks(,) As Block
    Private BlockBB As BoundingBox
    Private PlayerBB As BoundingBox
    Private BallBB As BoundingBox
    Private Player As String
    Private Balls(0) As Ball
    Private PlayerPosition As Vector3
    Private mobjMouse As DirectInput.Device
    Private mobjKB As DirectInput.Device
    ' Private ONEMILLI As Long = TimeSpan.TicksPerMillisecond
    Private PlayArea As New RectangleF(-500, -500, 1000, 1000)
    Private PlayAreaBB As BoundingBox


    Public Sub Run() Implements DXTTesterExt.IExample.Run

        DoInit()
        While mobjForm.Created
            ' get input
            Try
                Dim MS As DirectInput.MouseState
                MS = mobjMouse.CurrentMouseState
                PlayerPosition.X += MS.X
                '   PlayerPosition.Y += MS.Y
                If mobjKB.GetCurrentKeyboardState.Item(DirectX.DirectInput.Key.Escape) Then
                    mobjForm.Close()
                    Exit While
                Else

                End If
            Catch
                mobjForm.Close()
                Exit While
            End Try

            ' update player pos
            If PlayerPosition.X < PlayArea.Left Then PlayerPosition.X = PlayArea.Left
            If PlayerPosition.X > PlayArea.Right Then PlayerPosition.X = PlayArea.Right
            'If PlayerPosition.Y < PlayArea.Top + (PlayArea.Height / 2) Then PlayerPosition.Y = PlayArea.Top + (PlayArea.Height / 2)
            ' If PlayerPosition.Y > PlayArea.Bottom - PlayerBB.Size.Y Then PlayerPosition.Y = PlayArea.Bottom - PlayerBB.Size.Y

            ' update ball pos
            UpdateBallPosition()

            ' render the scene
            If RenderScene() = False Then Exit While

            Application.DoEvents()
        End While

        DoCleanUp()
    End Sub

    Private Sub DrawBB(ByVal Pos As Vector3, ByVal BB As BoundingBox)
        Dim Verts(4) As Direct3D.CustomVertex.PositionColored

        'Verts(0) = New Direct3D.CustomVertex.PositionColored(BB.Min.X + Pos.X, BB.Min.Y + Pos.Y, 0, Color.White.ToArgb)  ' top
        'Verts(1) = New Direct3D.CustomVertex.PositionColored(BB.Max.X + Pos.X, BB.Min.Y + Pos.Y, 0, Color.White.ToArgb) ' bottom
        'Verts(2) = New Direct3D.CustomVertex.PositionColored(BB.Max.X + Pos.X, BB.Max.Y + Pos.Y, 0, Color.White.ToArgb)  ' left
        'Verts(3) = New Direct3D.CustomVertex.PositionColored(BB.Min.X + Pos.X, BB.Max.Y + Pos.Y, 0, Color.White.ToArgb) ' right

        'Verts(0) = New Direct3D.CustomVertex.PositionColored(BB.Min.X, BB.Min.Y, 0, Color.White.ToArgb)    ' top
        'Verts(1) = New Direct3D.CustomVertex.PositionColored(BB.Max.X, BB.Min.Y, 0, Color.White.ToArgb)   ' bottom
        'Verts(2) = New Direct3D.CustomVertex.PositionColored(BB.Max.X, BB.Max.Y, 0, Color.White.ToArgb)    ' left
        'Verts(3) = New Direct3D.CustomVertex.PositionColored(BB.Min.X, BB.Max.Y, 0, Color.White.ToArgb)   ' right
        'Verts(4) = Verts(0)  ' top


        'With GetD3DDevice()
        '    .VertexFormat = Verts(0).Format
        '    Dim M As Matrix = Matrix.Identity
        '    M.Multiply(Matrix.Translation(Pos))
        '    SetWorldMatrix(M)
        '    ApplyTexture(0, NOTEXTURE)
        '    .DrawUserPrimitives(Direct3D.PrimitiveType.LineStrip, 4, Verts)
        'End With
        'Exit Sub
        BeginLineDrawing()

        DrawLine(BB.Min.X + Pos.X, BB.Min.Y + Pos.Y, BB.Max.X + Pos.X, BB.Min.Y + Pos.Y, Color.White) ' top
        DrawLine(BB.Min.X + Pos.X, BB.Max.Y + Pos.Y, BB.Max.X + Pos.X, BB.Max.Y + Pos.Y, Color.White) ' bottom
        DrawLine(BB.Min.X + Pos.X, BB.Min.Y + Pos.Y, BB.Min.X + Pos.X, BB.Max.Y + Pos.Y, Color.White) ' left
        DrawLine(BB.Max.X + Pos.X, BB.Min.Y + Pos.Y, BB.Max.X + Pos.X, BB.Max.Y + Pos.Y, Color.White) ' right
        EndLineDrawing()
    End Sub

    Private Sub UpdateBallPosition()
        Static LastTime As Long
        If Now.Ticks > LastTime + (TimeSpan.TicksPerMillisecond * 10) Then

            Dim pMin, pMax As Vector3
            Dim NewX, NewY As Single

            ' calc new position of the ball
            Displacement(Balls(0).X, Balls(0).Y, Balls(0).Speed, CSng(Math.PI / 180) * Balls(0).Direction, NewX, NewY)
            
            ' check if collided with player
            Dim Dist As Single
            If CircleCircle(NewX, NewY, BallBB.Size.X / 2, PlayerPosition.X, PlayerPosition.Y + 100, 100, Dist) Then
                ' calc dist from ball to player
                ' Dist = Distance(NewX, NewY, PlayerPosition.X, PlayerPosition.Y + 100)
                Dim Rot As Single
                ' get ball/player rotation
                'Rot = GetRotationInDegrees(NewX, NewY, PlayerPosition.X, PlayerPosition.Y + 100)
                Rot = Balls(0).Direction
                'Rot += 180
                If Rot >= 360 Then Rot -= 360
                Balls(0).Direction = Rot
                ' calc new pos of ball
                Displacement(Balls(0).X, Balls(0).Y, Math.Abs(Dist - (100 + (BallBB.Size.X / 2))), Rot, NewX, NewY)
                ' set new pos of ball
                Balls(0).X = NewX
                Balls(0).Y = NewY
            End If

            ' BallCollide(0, RS.X, RS.Y, RE.X, RE.Y, pMin.X, pMin.Y, pMax.X, pMax.Y)

            KeepBallsInPlayArea()

            LastTime = Now.Ticks
        End If
    End Sub

    Private Sub BallCollide(ByVal BallIndex As Integer, ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single, _
       ByVal Left As Single, ByVal Top As Single, ByVal Right As Single, ByVal Bottom As Single)

        Dim WhatCorner As Integer
        Dim OldX, OldY, NewX, NewY As Single
        OldX = Balls(BallIndex).X
        OldY = Balls(BallIndex).Y

        ' calc new position of the ball
        Displacement(OldX, OldY, Balls(BallIndex).Speed, DegreeToRadian(Balls(BallIndex).Direction), NewX, NewY)

        ' check if hit player
        Dim pMin, pMax, bMin, bMax, RS, RE As Vector3
        RS = New Vector3(OldX, OldY, 0)     ' ray start
        RE = New Vector3(NewX, NewY, 0) ' ray end
        pMin = Vector3.Add(PlayerBB.Min, PlayerPosition) ' player min bb
        pMax = Vector3.Add(PlayerBB.Max, PlayerPosition) ' player max bb
        bMin = Vector3.Add(BallBB.Min, Balls(BallIndex).Position)  ' ball min bb
        bMax = Vector3.Add(BallBB.Max, Balls(BallIndex).Position) ' ball max bb

        For WhatCorner = 0 To 3

            Select Case WhatCorner
                Case 0
                    bMin.Subtract(BallBB.GetHalfSize(BallBB)) ' new Vector3 ( ballbb.Size.X /2,ballbb.Size.X /2


                Case 1
                Case 2
                Case 3
            End Select


            Dim Rot As Single
            ' If Direct3D.Geometry.BoxBoundProbe(Min, Max, RS, RE) Then
            ' if hit then ...
            Dim RetX, RetY As Single

            If LineRect(RS.X, RS.Y, RE.X, RE.Y, pMin.X, pMin.Y, pMax.X, pMax.Y, RetX, RetY) Then

                '  End If
                Rot = GetRotationInDegrees(RS.X, RS.Y, PlayerPosition.X, PlayerPosition.Y + 100)
                ' If Balls(0).Y > PlayerPosition.Y Then
                '     Balls(0).Direction = 270
                '  Else
                Balls(BallIndex).Direction = Rot + 180
                '  End If


                If Balls(BallIndex).Direction >= 360 Then Balls(BallIndex).Direction = Balls(BallIndex).Direction - 360
                Balls(BallIndex).X = OldX
                Balls(BallIndex).Y = OldY '- 1 '- PlayerBB.Size.Y
            End If
        Next
    End Sub

    Private Sub KeepBallsInPlayArea()
        Dim Rot, NX, NY As Single


        Displacement(Balls(0).X, Balls(0).Y, Balls(0).Speed, DegreeToRadian(Balls(0).Direction), NX, NY)

        Rot = GetRotationInDegrees(Balls(0).X, Balls(0).Y, NX, NY)
        If Balls(0).X < PlayArea.Left Then
            If Rot < 180 And Rot >= 90 Then
                Balls(0).Direction = 180 - Rot
            ElseIf Rot < 270 And Rot >= 180 Then
                Balls(0).Direction = 270 + (270 - Rot)
            End If

            Balls(0).X = PlayArea.Left
        End If

        If Balls(0).X > PlayArea.Right Then
            If Rot < 90 And Rot >= 0 Then
                Balls(0).Direction = (90 - Rot) + 90
            ElseIf Rot < 360 And Rot >= 270 Then
                Balls(0).Direction = 270 - (Rot - 270)
            End If
            Balls(0).X = PlayArea.Right
        End If

        If Balls(0).Y < PlayArea.Top Then
            If Rot < 360 And Rot >= 270 Then
                Balls(0).Direction = 360 - Rot
            ElseIf Rot < 270 And Rot >= 180 Then
                Balls(0).Direction = 90 + (270 - Rot)
            End If
            Balls(0).Y = PlayArea.Top
        End If

        If Balls(0).Y > PlayArea.Bottom Then
            ResetBalls()
            'If Rot < 180 And Rot >= 90 Then
            '    Balls(0).Direction = 180 + (180 - Rot)
            'ElseIf Rot < 90 And Rot >= 0 Then
            '    Balls(0).Direction = 270 + (90 - Rot)
            'End If
            'Balls(0).Y = PlayArea.Bottom
        End If
    End Sub

    Private Function RenderScene() As Boolean
        If GraphicsDeviceIsLost() Then Return False
        BeginScene()

        SetProjectionMatrix(Matrix.OrthoOffCenterLH(0, mobjForm.ClientSize.Width, mobjForm.ClientSize.Height, 0, 0, 1000))
        '  ApplyEnabledLights()

        DrawTheBall()
        DrawBB(New Vector3(Balls(0).X, Balls(0).Y, Balls(0).Z), BallBB)

        DrawTheBlocks()

        DrawThePlayer()
        DrawBB(PlayerPosition, PlayerBB)
        'Dim M As Mesh
        'GetMesh("Player", M)
        'ApplyMaterial("White")
        'ApplyTexture(0, Nothing)
        'SetFillMode(DirectX.Direct3D.FillMode.WireFrame)
        '' M.Mesh.DrawSubset(0)

        '   DrawBB(New Vector3(), PlayAreaBB)
        EndScene()
        Return True
    End Function

    Private Sub DrawTheBlocks(Optional ByVal DrawBoundingBoxes As Boolean = False)
        Dim idx, idy As Integer
        For idy = 0 To Blocks.GetUpperBound(0)
            For idx = 0 To Blocks.GetUpperBound(1)
                Dim M As Matrix = Matrix.Identity
                M.Multiply(Matrix.Scaling(Blocks(idy, idx).ScaleX, Blocks(idy, idx).ScaleY, Blocks(idy, idx).ScaleZ))
                M.Multiply(Matrix.Translation(Blocks(idy, idx).X, Blocks(idy, idx).Y, Blocks(idy, idx).Z))
                SetWorldMatrix(M)
                DrawMesh(Blocks(idy, idx).Mesh)
                If DrawBoundingBoxes Then DrawBB(Blocks(idy, idx).Position, BlockBB)
            Next
        Next
    End Sub

    Private Sub DrawThePlayer()
        Dim M As Matrix = Matrix.Identity
        '  M.Multiply(Matrix.RotationYawPitchRoll(0, DegreeToRadian(180), 0))
        M.Multiply(Matrix.Translation(PlayerPosition))
        SetWorldMatrix(M)
        DrawMesh("Player")
    End Sub

    Private Sub DrawTheBall()
        Static Rot As Single
        Static LastTime As Long
        If Now.Ticks > LastTime + (TimeSpan.TicksPerMillisecond * 10) Then
            Rot += 0.1F
            LastTime = Now.Ticks
        End If

        Dim Tm As Matrix = Matrix.Identity
        Dim M As Matrix = Matrix.Identity

        M.M31 = -0.5 : M.M32 = -0.5 : Tm.Multiply(M)
        Tm.Multiply(Matrix.RotationZ(CSng(Math.Sin(Rot))))
        M.M31 = 0.5 : M.M32 = 0.5 : Tm.Multiply(M)

        SetTransform(DirectX.Direct3D.TransformType.Texture0, Tm)

        M = Matrix.Identity
        M.Multiply(Matrix.Translation(Balls(0).X, Balls(0).Y, Balls(0).Z))
        SetWorldMatrix(M)
        DrawMesh("BallRing")
        SetTransform(DirectX.Direct3D.TransformType.Texture0, Matrix.Identity)
        DrawMesh("Ball")
    End Sub

    Protected Friend Overrides Sub DoCleanUp()
        If mobjMouse Is Nothing = False Then mobjMouse.Dispose()
        mobjMouse = Nothing
        If mobjKB Is Nothing = False Then mobjKB.Dispose()
        mobjKB = Nothing
        mobjForm.Cursor.Show()
        ' RemoveHandler mobjForm.Click, AddressOf Form_Click
        '  RemoveHandler mobjForm.KeyDown, AddressOf Form_KeyDown
        MyBase.DoCleanUp()
    End Sub

    Protected Overrides Sub DoInit(Optional ByVal Windowed As Boolean = True)
        MyBase.DoInit(Windowed)

        Dim R As Rectangle = mobjForm.ClientRectangle
        PlayArea = RectangleF.FromLTRB(R.Left, R.Top, R.Right, R.Bottom)
        PlayAreaBB = New BoundingBox()
        PlayAreaBB.Size = New Vector3(PlayArea.Width, PlayArea.Height, 0)

        '' check if display modes ara availible
        'Dim Fmt As Direct3D.Format
        'If ModeAvailible(0, 640, 480, Direct3D.Format.X8R8G8B8) Then
        '    Fmt = Direct3D.Format.X8R8G8B8 ' found availible 32bit mode
        'ElseIf ModeAvailible(0, 640, 480, Direct3D.Format.A8R8G8B8) Then
        '    Fmt = Direct3D.Format.A8B8G8R8 ' found availible 32bit mode
        'ElseIf ModeAvailible(0, 640, 480, Direct3D.Format.R8G8B8) Then
        '    Fmt = Direct3D.Format.R8G8B8  ' found availible 16bit mode
        'Else
        '    MsgBox("Error: A 640x480 diaplay format does not appear to be availible. The game cannot be played.")
        '    MyBase.DoCleanUp()
        '    Exit Sub
        'End If

        ' InitGraphics(mobjForm, False, 640, 480, Fmt)
        mobjForm.Text = "Blastroidz"
        mobjForm.Cursor.Hide()
        ' AddHandler mobjForm.Click, AddressOf Form_Click
        ' AddHandler mobjForm.KeyDown, AddressOf Form_KeyDown

        AddMaterial("White", Color.White, Color.White, True)

        Dim Dev As Direct3D.Device = GetD3DDevice()

        ' load geometry
        Dim vFmt As Direct3D.VertexFormats = Direct3D.CustomVertex.PositionNormalTextured.Format
        AddHandler GetEvents.LoadMesh, AddressOf LoadMeshHandler
        LoadMesh("BallRing", LoadResource("BallRing.X", "Blastroidz."), vFmt, DirectX.Direct3D.MeshFlags.Managed)
        LoadMesh("Ball", LoadResource("Ball.X", "Blastroidz."), vFmt, DirectX.Direct3D.MeshFlags.Managed)
        LoadMesh("Player", LoadResource("Paddle.X", "Blastroidz."), vFmt, DirectX.Direct3D.MeshFlags.Managed)
        LoadMesh("Block", LoadResource("RoundedBox.X", "Blastroidz."), vFmt, DirectX.Direct3D.MeshFlags.Managed)
        RemoveHandler GetEvents.LoadMesh, AddressOf LoadMeshHandler

        Dim Ret As String
        GetMeshMaterial("BallRing", 0, Ret)
        SetMaterial(Ret, Color.FromArgb(128, 255, 255, 255), Color.FromArgb(128, 255, 255, 255))

        ' calc bounding boxes
        PlayerBB = CalcBoundingBox("Player")
        BlockBB = CalcBoundingBox("Block")
        BallBB = BoundingBox.Combine(CalcBoundingBox("Ball"), CalcBoundingBox("BallRing"))

        ' setup cameras
        ' AddCamera("Main", 0, 0, -PlayArea.Width, 0, 0, 0, 0, 1, 0, Math.PI / 4, 0, 10000, True)

        EnableLighting(False)
        SetAmbientLighting(Color.White)
        ' SetCullMode(DirectX.Direct3D.Cull.None)
        SetTextureTransform(0, DirectX.Direct3D.TextureTransform.Count2)

        AddLight("Main", CreateDirectionalLight(0, 0, -500, 0, 0, 0, Color.White), True)

        'Dim Mesh As New Mesh()
        'Mesh.Mesh = Direct3D.Mesh.FromStream(LoadResource("SkyBox.X"), Direct3D.MeshFlags.Managed, Dev)
        'Mesh.Materials.Add("White")
        'Mesh.Textures.Add("Back")
        'AddMesh("Sky", Mesh)

        ' setup blocks
        ReDim Blocks(CInt(PlayArea.Width / BlockBB.Size.X - 1), 2)
        Dim idx, idy As Integer
        For idy = 0 To Blocks.GetUpperBound(0)
            For idx = 0 To Blocks.GetUpperBound(1)
                Dim B As Block
                B = New Block()
                B.Mesh = "Block"
                B.ScaleX = 0.5
                B.ScaleY = 0.5
                B.ScaleZ = 0.5
                Dim BS As Vector3 ' actrual scaled block size
                BS = New Vector3(BlockBB.Size.X * B.ScaleX, BlockBB.Size.Y * B.ScaleY, BlockBB.Size.Z * B.ScaleZ)
                B.X = (idy * BS.X) + (BS.X / 2)
                B.Y = (idx * BS.Y) + (BS.Y / 2)
                B.Distroyed = False
                Blocks(idy, idx) = B
            Next
        Next

        ResetBalls()
        ' PlayerPosition = New Vector3(0, PlayArea.Top - -(PlayerBB.Size.Y * 2), 0)
        PlayerPosition = New Vector3(PlayArea.Width / 2, PlayArea.Bottom - PlayerBB.Size.Y, 0)


        mobjMouse = New DirectInput.Device(DirectInput.SystemGuid.Mouse)
        mobjKB = New DirectInput.Device(DirectInput.SystemGuid.Keyboard)

        mobjMouse.SetCooperativeLevel(mobjForm, NonExclusive Or Background) ' Exclusive Or Foreground)
        mobjKB.SetCooperativeLevel(mobjForm, NonExclusive Or Background) 'Exclusive Or Foreground)

        mobjMouse.Acquire()
        mobjKB.Acquire()
    End Sub

    Private Sub ResetBalls()
        Balls(0) = New Ball()
        Balls(0).X = PlayArea.Width / 2
        Balls(0).Y = PlayArea.Height / 2
        Balls(0).Direction = 90
        Balls(0).Speed = 10
    End Sub

    Private Function CalcBoundingBox(ByVal MeshName As String) As BoundingBox
        Dim Mesh As Mesh
        Dim Min, Max As Vector3
        Dim GS As Direct3D.GraphicsStream
        Dim BB As New BoundingBox()

        GetMesh(MeshName, Mesh)
        GS = Mesh.Mesh.LockVertexBuffer(DirectX.Direct3D.LockFlags.ReadOnly)
        Direct3D.Geometry.ComputeBoundingBox(GS, Mesh.Mesh.NumberVertices, Mesh.Mesh.VertexFormat, BB.Min, BB.Max)
        Mesh.Mesh.UnlockVertexBuffer()

        ' BB.Size = Vector3.Subtract(BB.Max, BB.Min)
        Return BB
    End Function

    'Protected Friend Overrides Function LoadResource(ByVal ResourceName As String, Optional ByVal PrePend As String = "DX9Tools_Tester.") As IO.MemoryStream
    '    Dim ResourceStream As IO.Stream
    '    ResourceStream = Reflection.Assembly.GetExecutingAssembly.GetManifestResourceStream(PrePend & ResourceName)
    '    If ResourceStream Is Nothing Then Return Nothing

    '    Dim byts(CInt(ResourceStream.Length - 1)) As Byte
    '    Dim Len As Integer = ResourceStream.Read(byts, 0, CInt(ResourceStream.Length))

    '    Dim MemStream As New IO.MemoryStream(byts, 0, Len)
    '    Return MemStream
    'End Function

    Private Sub LoadMeshHandler(ByVal MeshName As String, ByVal TextureFilename As String, ByRef Texture As Direct3D.Texture, ByRef TextureName As String)
        Dim TexPath As String = IO.Path.GetFileName(TextureFilename)
        If AddTexture(TexPath, LoadResourceImage(TexPath, "Blastroidz.")) = False Then
            ' error
        Else
            GetTexture(TexPath, Texture)
            TextureName = TexPath
        End If
    End Sub

    'Private Sub Form_Click(ByVal sender As Object, ByVal e As System.EventArgs)
    '    mobjForm.Close()
    'End Sub

    'Private Sub Form_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
    '    mobjForm.Close()
    'End Sub

    Public Function GetDescription() As String Implements DXTTesterExt.IExample.GetDescription
        Return "A basic breakout style game."
    End Function

    Public Function GetImage() As System.Drawing.Image Implements DXTTesterExt.IExample.GetImage
        Return Nothing 'New Bitmap(Me.GetType, "D3DFullScreen.png")
    End Function

    Public Function GetName() As String Implements DXTTesterExt.IExample.GetName
        Return "Blastroidz"
    End Function
End Class