'Created by: X
'Copyright: Created by: X
'Web: http://www.createdbyx.com/
'Date: Sunday, April 24, 2005
'=============================================


Public Class BoundingBox
    Inherits Boundary

    Public Min As Vector3
    Public Max As Vector3
    Public Center As Vector3

    Public Shared Function GetHalfSize(ByVal BB As BoundingBox) As Vector3
        Dim S As Vector3 = BB.Size
        Return New Vector3(S.X / 2, S.Y / 2, S.Z / 2)
    End Function

    Public Property Size() As Vector3
        Get
            Return Vector3.Subtract(Me.Max, Me.Min)
        End Get
        Set(ByVal Value As Vector3)
            Dim V As New Vector3(Value.X / 2, Value.Y / 2, Value.Z / 2)
            Me.Max = New Vector3(-Math.Abs(V.X), -Math.Abs(V.Y), -Math.Abs(V.Z))
            Me.Min = New Vector3(Math.Abs(V.X), Math.Abs(V.Y), Math.Abs(V.Z))
        End Set
    End Property

    Public Shared Function Combine(ByVal A As BoundingBox, ByVal B As BoundingBox) As BoundingBox
        Dim Value As New BoundingBox()
        Value.Max.X = Math.Max(A.Max.X, B.Max.X)
        Value.Max.Y = Math.Max(A.Max.Y, B.Max.Y)
        Value.Max.Z = Math.Max(A.Max.Z, B.Max.Z)
        Value.Min.X = Math.Min(A.Min.X, B.Min.X)
        Value.Min.Y = Math.Min(A.Min.Y, B.Min.Y)
        Value.Min.Z = Math.Min(A.Min.Z, B.Min.Z)
        ' Value.Size = Vector3.Subtract(Value.Max, Value.Min)
        Return Value
    End Function
End Class