'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@gmail.com
'Web: http://www.createdbyx.com/
'Date: December 23, 2004
'=============================================

Public Class D3DWindowed
    Inherits DXTTesterExt.BaseExample
    Implements DXTTesterExt.IExample

    Public Sub Run() Implements DXTTesterExt.IExample.Run
        DoInit()
        While mobjForm.Created
            BeginScene()

            DrawText("Click or press any key to exit...", 50, 50)

            EndScene()

            Application.DoEvents()
        End While

        DoCleanUp()
    End Sub

    Protected Friend Overrides Sub DoCleanUp()
        If mobjForm Is Nothing = False Then
            RemoveHandler mobjForm.Click, AddressOf Form_Click
            RemoveHandler mobjForm.KeyDown, AddressOf Form_KeyDown
        End If
        MyBase.DoCleanUp()
    End Sub

    Protected Overrides Sub DoInit(Optional ByVal Windowed As Boolean = True)
        MyBase.DoInit()

        mobjForm.Text = "D3D Windowed Example"
        AddHandler mobjForm.Click, AddressOf Form_Click
        AddHandler mobjForm.KeyDown, AddressOf Form_KeyDown
    End Sub

    Private Sub Form_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        mobjForm.Close()
    End Sub

    Private Sub Form_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        mobjForm.Close()
    End Sub

    Public Function GetDescription() As String Implements DXTTesterExt.IExample.GetDescription
        Return "Demonstrates a basic D3D windows app."
    End Function

    Public Function GetImage() As System.Drawing.Image Implements DXTTesterExt.IExample.GetImage
        Return New Bitmap(Me.GetType, "Windowed.png")
    End Function

    Public Function GetName() As String Implements DXTTesterExt.IExample.GetName
        Return "D3D Windowed"
    End Function
End Class