﻿'Created by: X
'Copyright: Created by: X
'Web: http://www.createdbyx.com/
'Date: Tuesday, April 05, 2005
'=============================================

Public Module General
    Friend mobjLastError As New DX9TError
    Friend gobjEvents As New Events()


    Public Function GetEvents() As Events
        Return gobjEvents
    End Function

    '#If TRACE Then
    '    Dim DebugFile As String
    '            DebugFile = IO.Path.Combine(IO.Path.GetDirectoryName(Application.ExecutablePath), My.Application.AssemblyInfo.Title & ".log")
    '            If IO.File.Exists(DebugFile) Then IO.File.Delete(DebugFile)
    '            Trace.Listeners.Add(New Diagnostics.TextWriterTraceListener(DebugFile, My.Application.AssemblyInfo.Title))
    '            Trace.AutoFlush = True
    '#End If
#If Trace Then


    Friend Sub Log(ByVal Message As String, Optional ByVal MultiLine As Boolean = False, _
                   Optional ByVal CategorySpacing As Integer = 16, Optional ByVal UTSpacing As Integer = 90, _
                   Optional ByVal WriteCategory As Boolean = True, Optional ByVal WriteUTStamp As Boolean = True)
        Dim Msg As String
        Dim Len As Integer

        Len = CategorySpacing - Application.ProductName.Length + 2
        Msg = IIf(Len < 0, "", Space(Len)).ToString
        Msg &= Message
        Len += UTSpacing - Msg.Length
        If WriteUTStamp Then
            If Len < 0 Then Len = 0
            Msg &= IIf(Len < 0, "", Space(Len)).ToString & Now.ToUniversalTime.ToString
        End If

        Dim Cat As String = Nothing
        If WriteCategory Then Cat = Application.ProductName

        If MultiLine Then
            Trace.Write(Msg & vbCrLf, Cat)
        Else
            Trace.WriteLine(Msg, Cat)
        End If
    End Sub
#End If

    'Public Function InitDX9Tools() As Boolean
    '    gobjEvents = New Events()
    'End Function

    Public Sub RemoveAllStoredResources(Optional ByVal CallDispose As Boolean = True)
        RemoveAllCameras()
        RemoveAllFonts(CallDispose)
        RemoveAllLights(True)
        RemoveAllMaterials()
        RemoveAllMeshes(CallDispose)
        RemoveAllTextures(CallDispose)
        RemoveAllRenderToSurface(CallDispose)
        RemoveAllVertexBuffers(CallDispose)
        RemoveAllViewports()
        RemoveAllAnimations()
        ' gobjEvents = Nothing
    End Sub

    Public Function GetLastError() As DX9TError
        Return mobjLastError
    End Function

    Friend Sub SpecifyError(Optional ByVal Source As String = "", Optional ByVal Message As String = "")
        mobjLastError.Source = Source
        mobjLastError.Message = Message
    End Sub
End Module

Public Class DX9TError
    Public Source As String
    Public Message As String

    ' we specify friend to prevent external assemblies from creating the object
    Friend Sub New()

    End Sub
End Class