' Code originally written in VB6. Converted to vb.net by -> Created by: X
' Special thanks to game_maker from which this code is based.
' Original Author: game_maker (from the http://www.vbgamer.com/ fourms)
' Real Name: Yazeed  
' Location: Ryiadh, Saudi Arabia
' HomePage: http://axdteam.com/
'--------------------------------------------------------


Friend Module MathFunctions
    Public Function SameSide(ByRef P1 As PointF, ByRef P2 As PointF, ByRef A As PointF, ByRef B As PointF) As Boolean
        'Dim V1, V2 As BaseDataTypes.Vector2D
        Dim N, M As Single
        N = CrossProduct(Make(A, B), Make(A, P1))
        M = CrossProduct(Make(A, B), Make(A, P2))
        Return DotProductZ(N, M) >= 0
    End Function

    Public Function CrossProduct(ByRef V1 As PointF, ByRef V2 As PointF) As Single
        Return V1.X * V2.Y - V1.Y * V2.X
    End Function

    Public Function DotProductZ(ByRef N As Single, ByRef M As Single) As Single
        Return N * M
    End Function

    Public Function GetSLength(ByRef V1 As PointF, ByRef V2 As PointF) As Single
        Return (V2.X - V1.X) * (V2.X - V1.X) + (V2.Y - V1.Y) * (V2.Y - V1.Y)
    End Function

    Public Function GetLength(ByRef V1 As PointF, ByRef V2 As PointF) As Single
        Return Convert.ToSingle(System.Math.Sqrt(GetSLength(V1, V2)))
    End Function

    Public Function Make(ByRef P1 As PointF, ByRef P2 As PointF) As PointF
        Return New PointF(P2.X - P1.X, P2.Y - P1.Y)
    End Function

    Public Function GetRotation(ByRef SX As Single, ByVal SY As Single, ByVal DX As Single, ByVal DY As Single) As Single
        Dim Slope As Single
        Dim Angle As Single

        Slope = System.Math.Abs(DY - SY) / System.Math.Abs(DX - SX)
        Angle = Convert.ToSingle(System.Math.Atan(Slope))
        If DY < SY Then
            If DX < SX Then ' upleft
                Return (Angle * 57.29578!) + 180
            Else ' upright
                Return -(Angle * 57.29578!) + 360
            End If
        Else
            If DX < SX Then ' low left
                Return -(Angle * 57.29578!) + 180
            Else 'low right
                ' do nothing
                Return Angle * 57.29578!
            End If
        End If
    End Function
End Module