'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@gmail.com
'Web: http://www.createdbyx.com/
'Date: December 17, 2004
'=============================================

Public Module GraphicsHelpers

    '#Region " ModeAvailible overloads ... "
    '    ''' <summary>
    '    ''' Used to help determin what display modes are availible.
    '    ''' </summary>
    '    ''' <param name="AdapterIndex">The index of the adapter to test.</param>
    '    ''' <param name="Width">The width of the display mode to test for.</param>
    '    ''' <param name="Height">The height of the display mode to test for.</param>
    '    ''' <param name="Format">The display format of the display mode to test for.</param>
    '    ''' <returns>Returns True if successfull.</returns>
    '    Public Function ModeAvailible(ByVal AdapterIndex As Integer, ByVal Width As Integer, ByVal Height As Integer, ByVal Format As Direct3D.Format) As Boolean
    '        Dim Mode As Direct3D.DisplayMode

    '        With Direct3D.Manager.Adapters.Item(AdapterIndex)
    '            With .SupportedDisplayModes.Item(Format).GetEnumerator
    '                .Reset()
    '                While .MoveNext
    '                    Mode = CType(.Current, Direct3D.DisplayMode)
    '                    If Mode.Format = Format And _
    '                    Mode.Width = Width And _
    '                    Mode.Height = Height Then
    '                        Return True
    '                    End If
    '                End While
    '            End With
    '        End With

    '        Return False
    '    End Function

    '    ''' <summary>
    '    ''' Used to help determin what display modes are availible.
    '    ''' </summary>
    '    ''' <param name="AdapterIndex">The index of the adapter to test.</param>
    '    ''' <param name="Size">Represents the width and height to test for.</param>
    '    ''' <param name="Format">The display format of the display mode to test for.</param>
    '    ''' <returns>Returns True if successfull.</returns>
    '    Public Function ModeAvailible(ByVal AdapterIndex As Integer, ByVal Size As Size, ByVal Format As Direct3D.Format) As Boolean
    '        Return ModeAvailible(AdapterIndex, Size.Width, Size.Height, Format)
    '    End Function

    '    ''' <summary>
    '    ''' Used to help determin what display modes are availible.
    '    ''' </summary>
    '    ''' <param name="AdapterIndex">The index of the adapter to test.</param>
    '    ''' <param name="Size">Represents the width and height to test for.</param>
    '    ''' <param name="Format">The display format of the display mode to test for.</param>
    '    ''' <returns>Returns True if successfull.</returns>
    '    Public Function ModeAvailible(ByVal AdapterIndex As Integer, ByVal Size As SizeF, ByVal Format As Direct3D.Format) As Boolean
    '        Return ModeAvailible(AdapterIndex, CInt(Size.Width), CInt(Size.Height), Format)
    '    End Function

    '    ''' <summary>
    '    ''' Used to help determin what display modes are availible.
    '    ''' </summary>
    '    ''' <param name="AdapterIndex">The index of the adapter to test.</param>
    '    ''' <param name="Width">The width of the display mode to test for.</param>
    '    ''' <param name="Height">The height of the display mode to test for.</param>
    '    ''' <param name="BitDepth">The bit depth to test for. Only 16bit or 32bit is allowed otherwise argument exception is raised.</param>
    '    ''' <returns>Returns True if successfull.</returns>
    '    Public Function ModeAvailible(ByVal AdapterIndex As Integer, ByVal Width As Integer, ByVal Height As Integer, ByVal BitDepth As Integer) As Boolean
    '        Select Case BitDepth
    '            Case 16
    '                Return ModeAvailible(AdapterIndex, Width, Height, Direct3D.Format.R5G6B5)
    '            Case 32
    '                Return ModeAvailible(AdapterIndex, Width, Height, Direct3D.Format.X8R8G8B8)

    '            Case Else
    '                Throw New ArgumentException("Bad value passed. Only 16 or 32 is acceptable.", "BitDepth")
    '        End Select
    '    End Function

    '    ''' <summary>
    '    ''' Used to help determin what display modes are availible.
    '    ''' </summary>
    '    ''' <param name="AdapterIndex">The index of the adapter to test.</param>
    '    ''' <param name="Size">Represents the width and height to test for.</param>
    '    ''' <param name="BitDepth">The bit depth to test for. Only 16bit or 32bit is allowed otherwise argument exception is raised.</param>
    '    ''' <returns>Returns True if successfull.</returns>
    '    Public Function ModeAvailible(ByVal AdapterIndex As Integer, ByVal Size As Size, ByVal BitDepth As Integer) As Boolean
    '        Select Case BitDepth
    '            Case 16
    '                Return ModeAvailible(AdapterIndex, Size.Width, Size.Height, Direct3D.Format.R5G6B5)
    '            Case 32
    '                Return ModeAvailible(AdapterIndex, Size.Width, Size.Height, Direct3D.Format.X8R8G8B8)

    '            Case Else
    '                Throw New ArgumentException("Bad value passed. Only 16 or 32 is acceptable.", "BitDepth")
    '        End Select
    '    End Function

    '    ''' <summary>
    '    ''' Used to help determin what display modes are availible.
    '    ''' </summary>
    '    ''' <param name="AdapterIndex">The index of the adapter to test.</param>
    '    ''' <param name="Size">Represents the width and height to test for.</param>
    '    ''' <param name="BitDepth">The bit depth to test for. Only 16bit or 32bit is allowed otherwise argument exception is raised.</param>
    '    ''' <returns>Returns True if successfull.</returns>
    '    Public Function ModeAvailible(ByVal AdapterIndex As Integer, ByVal Size As SizeF, ByVal BitDepth As Integer) As Boolean
    '        Select Case BitDepth
    '            Case 16
    '                Return ModeAvailible(AdapterIndex, CInt(Size.Width), CInt(Size.Height), Direct3D.Format.R5G6B5)
    '            Case 32
    '                Return ModeAvailible(AdapterIndex, CInt(Size.Width), CInt(Size.Height), Direct3D.Format.X8R8G8B8)

    '            Case Else
    '                Throw New ArgumentException("Bad value passed. Only 16 or 32 is acceptable.", "BitDepth")
    '        End Select
    '    End Function

    '    ''' <summary>
    '    ''' Used to help determin what display modes are availible.
    '    ''' </summary>
    '    ''' <param name="AdapterIndex">The index of the adapter to test.</param>
    '    ''' <param name="Mode">A Direct3D.DisplayMode type representing the display mode to test for.</param>
    '    ''' <returns>Returns True if successfull.</returns>
    '    Public Function ModeAvailible(ByVal AdapterIndex As Integer, ByVal Mode As Direct3D.DisplayMode) As Boolean
    '        Return ModeAvailible(AdapterIndex, Mode.Width, Mode.Height, Mode.Format)
    '    End Function

    '    ''' <summary>
    '    ''' Checks to see if a specific direct draw display mode is availible.
    '    ''' </summary>
    '    ''' <param name="Width">The width of the display mode.</param>
    '    ''' <param name="Height">The height of the display mode.</param>
    '    ''' <param name="BitCount">The bitcount of the display mode. For example you would specify 16 for a 16bit color mode etc. </param>
    '    ''' <returns>Will return True if the mode is available else False if it is not.</returns>
    '    Public Function ModeAvailible(ByVal Device As DirectDraw.Device, ByVal Width As Integer, ByVal Height As Integer, ByVal BitCount As Integer) As Boolean
    '        Dim Desc As DirectDraw.SurfaceDescription
    '        Dim Modes As DirectDraw.DisplayModesCollection

    '        Modes = New DirectDraw.DisplayModesCollection(Device)
    '        For Each Desc In Modes
    '            If Desc.Width = Width And Desc.Height = Height Then
    '                If Desc.PixelFormatStructure.RgbBitCount = BitCount Then Return True
    '            End If
    '        Next

    '        Return False
    '    End Function
    '#End Region

#Region " CaptureScreenshot ... "
    ''' <summary>
    ''' Captures a screen shot.
    ''' </summary>
    ''' <param name="Device">The revice to capture the screen shot from.</param>
    ''' <param name="Filename">The filename to save the image file to.</param>
    ''' <param name="ImageFormat">The file format to save the image as.</param>
    ''' <returns>If the screen capture was successfull then CaptureScreenshot will return True.</returns>
    ''' <remarks>
    ''' This method will save a screen shot using the specified image format from the ImageFormat parameter regardless 
    ''' of what filename extention is specified in the Filename parameter.
    ''' Note that the CaptureScreenshot method saves the contents of the devices backbuffer, so make sure you don't
    ''' do a clear before capturing a screen shot.
    ''' </remarks>
    Public Function CaptureScreenshot(ByVal Filename As String, ByVal ImageFormat As Direct3D.ImageFileFormat) As Boolean
        If mblnHasBeenInit = False Then Return False
        If mblnBeginScene Then Return False

        Try
            Dim B As Direct3D.Surface
            ' get back buffer
            B = mobjDevice.GetBackBuffer(0, 0, Direct3D.BackBufferType.Mono)

            ' save capture image
            Direct3D.SurfaceLoader.Save(Filename, ImageFormat, B)
            B.Dispose()
        Catch ex As Exception
            Return False
        End Try

        Return True
    End Function

    ''' <summary>
    ''' Captures a screen shot.
    ''' </summary>
    ''' <param name="Device">The revice to capture the screen shot from.</param>
    ''' <param name="Filename">The filename to save the image file to.</param>
    ''' <param name="ImageFormat">The file format to save the image as.</param>
    ''' <returns>If the screen capture was successfull then CaptureScreenshot will return True.</returns>
    ''' <remarks>
    ''' Since no image format is specified CaptureScreenshot will try to save the image using the *.bmp format.
    ''' Regardless of what filename extention is specified in the Filename parameter.
    ''' Note that the CaptureScreenshot method saves the contents of the devices backbuffer, so make sure you don't
    ''' do a clear before capturing a screen shot.
    ''' </remarks>
    Public Function CaptureScreenshot(ByVal Filename As String) As Boolean
        Return CaptureScreenshot(Filename, Direct3D.ImageFileFormat.Bmp)
    End Function
#End Region

#Region " BuildMatrix overloads ... "
    Public Function BuildMatrix(ByVal AxisX As Single, ByVal AxisY As Single, ByVal AxisZ As Single, _
                                ByVal ScaleX As Single, ByVal ScaleY As Single, ByVal ScaleZ As Single, _
                                ByVal TranslationX As Single, ByVal TranslationY As Single, ByVal TranslationZ As Single, _
                                ByVal RotationX As Single, ByVal RotationY As Single, ByVal RotationZ As Single, _
                                ByVal Base As Matrix) As Matrix
        Dim WM As Matrix = Matrix.Identity
        ' setup world transform
        WM.Multiply(Matrix.Scaling(ScaleX, ScaleY, ScaleZ))
        WM.Multiply(Matrix.Translation(AxisX, AxisY, AxisZ))
        WM.Multiply(Matrix.RotationYawPitchRoll(RotationX, RotationY, RotationZ))
        WM.Multiply(Matrix.Translation(TranslationX, TranslationY, TranslationZ))
        WM.Multiply(Base)
        Return WM
    End Function

    Public Function BuildMatrix(ByVal AxisX As Single, ByVal AxisY As Single, ByVal AxisZ As Single, _
                                ByVal ScaleX As Single, ByVal ScaleY As Single, ByVal ScaleZ As Single, _
                                ByVal TranslationX As Single, ByVal TranslationY As Single, ByVal TranslationZ As Single, _
                                ByVal RotationX As Single, ByVal RotationY As Single, ByVal RotationZ As Single) As Matrix
        Return BuildMatrix(AxisX, AxisY, AxisZ, ScaleX, ScaleY, ScaleZ, TranslationX, TranslationY, TranslationZ, _
                           RotationX, RotationY, RotationZ, Matrix.Identity)
    End Function

    Public Function BuildMatrix(ByVal Axis As Vector3, ByVal Scale As Vector3, ByVal Translation As Vector3, ByVal Rotation As Vector3, _
                                ByVal Base As Matrix) As Matrix
        Return BuildMatrix(Axis.X, Axis.Y, Axis.Z, Scale.X, Scale.Y, Scale.Z, Translation.X, Translation.Y, Translation.Z, _
                           Rotation.X, Rotation.Y, Rotation.Z, Base)
    End Function

    Public Function BuildMatrix(ByVal Axis As Vector3, ByVal Scale As Vector3, ByVal Translation As Vector3, ByVal Rotation As Vector3) As Matrix
        Return BuildMatrix(Axis.X, Axis.Y, Axis.Z, Scale.X, Scale.Y, Scale.Z, Translation.X, Translation.Y, Translation.Z, _
                           Rotation.X, Rotation.Y, Rotation.Z, Matrix.Identity)
    End Function

    Public Function BuildMatrix(ByVal ScaleX As Single, ByVal ScaleY As Single, ByVal ScaleZ As Single, _
                               ByVal TranslationX As Single, ByVal TranslationY As Single, ByVal TranslationZ As Single, _
                               ByVal RotationX As Single, ByVal RotationY As Single, ByVal RotationZ As Single, _
                               ByVal Base As Matrix) As Matrix
        Return BuildMatrix(0, 0, 0, ScaleX, ScaleY, ScaleZ, TranslationX, TranslationY, TranslationZ, RotationX, RotationY, RotationZ, Matrix.Identity)

    End Function

    Public Function BuildMatrix(ByVal ScaleX As Single, ByVal ScaleY As Single, ByVal ScaleZ As Single, _
                                ByVal TranslationX As Single, ByVal TranslationY As Single, ByVal TranslationZ As Single, _
                                ByVal RotationX As Single, ByVal RotationY As Single, ByVal RotationZ As Single) As Matrix
        Return BuildMatrix(0, 0, 0, ScaleX, ScaleY, ScaleZ, TranslationX, TranslationY, TranslationZ, _
                           RotationX, RotationY, RotationZ, Matrix.Identity)
    End Function

    Public Function BuildMatrix(ByVal Scale As Vector3, ByVal Translation As Vector3, ByVal Rotation As Vector3, ByVal Base As Matrix) As Matrix
        Return BuildMatrix(0, 0, 0, Scale.X, Scale.Y, Scale.Z, Translation.X, Translation.Y, Translation.Z, _
                           Rotation.X, Rotation.Y, Rotation.Z, Base)
    End Function

    Public Function BuildMatrix(ByVal Scale As Vector3, ByVal Translation As Vector3, ByVal Rotation As Vector3) As Matrix
        Return BuildMatrix(0, 0, 0, Scale.X, Scale.Y, Scale.Z, Translation.X, Translation.Y, Translation.Z, _
                           Rotation.X, Rotation.Y, Rotation.Z, Matrix.Identity)
    End Function
#End Region

    Public Function GetTextureWidth(ByVal Name As String, ByRef Value As Integer, Optional ByVal MipMap As Integer = 0) As Boolean
        If mblnHasBeenInit = False Then Return False
        Dim Tex As Direct3D.Texture
        If GetTexture(Name, Tex) = False Then Return False
        Value = Tex.GetSurfaceLevel(MipMap).Description.Width
        Return True
    End Function

    Public Function GetTextureHeight(ByVal Name As String, ByRef Value As Integer, Optional ByVal MipMap As Integer = 0) As Boolean
        If mblnHasBeenInit = False Then Return False
        Dim Tex As Direct3D.Texture
        If GetTexture(Name, Tex) = False Then Return False
        Value = Tex.GetSurfaceLevel(MipMap).Description.Height
        Return True
    End Function

    Public Function GetTextureSize(ByVal Name As String, ByRef Size As Size, Optional ByVal MipMap As Integer = 0) As Boolean
        If mblnHasBeenInit = False Then Return False
        Dim Tex As Direct3D.Texture
        If GetTexture(Name, Tex) = False Then Return False
        Dim S As Size
        With Tex.GetSurfaceLevel(MipMap).Description
            S = New Size(.Width, .Height)
        End With
        Size = S
        Return True
    End Function

    Public Function SetTextureTransform(ByVal Stage As Integer, ByVal Value As Direct3D.TextureTransform) As Boolean
        If mblnHasBeenInit = False Then Return False
        mobjDevice.TextureState(Stage).TextureTransform = Value
        Return True
    End Function

    Public Function GetTextureTransform(ByVal Stage As Integer, ByRef Value As Direct3D.TextureTransform) As Boolean
        If mblnHasBeenInit = False Then Return False
        Value = mobjDevice.TextureState(Stage).TextureTransform
        Return True
    End Function

    Public Function SetTextureAddress(ByVal Stage As Integer, ByVal U As Direct3D.TextureAddress, ByVal V As Direct3D.TextureAddress) As Boolean
        If mblnHasBeenInit = False Then Return False
        mobjDevice.SamplerState(Stage).AddressU = U
        mobjDevice.SamplerState(Stage).AddressU = V
        Return True
    End Function

    Public Function SetTextureAddress(ByVal Stage As Integer, ByVal Value As Direct3D.TextureAddress) As Boolean
        If mblnHasBeenInit = False Then Return False
        mobjDevice.SamplerState(Stage).AddressU = Value
        mobjDevice.SamplerState(Stage).AddressU = Value
        Return True
    End Function

    Public Function SetTransform(ByVal Transform As Direct3D.TransformType, ByVal Value As Matrix) As Boolean
        If mblnHasBeenInit = False Then Return False
        mobjDevice.SetTransform(Transform, Value)
        Return True
    End Function

    Public Function SetWorldMatrix(ByVal Value As Matrix) As Boolean
        If mblnHasBeenInit = False Then Return False
        mobjDevice.Transform.World = Value
        Return True
    End Function

    Public Function SetViewMatrix(ByVal Value As Matrix) As Boolean
        If mblnHasBeenInit = False Then Return False
        mobjDevice.Transform.View = Value
        Return True
    End Function

    Public Function SetProjectionMatrix(ByVal Value As Matrix) As Boolean
        If mblnHasBeenInit = False Then Return False
        mobjDevice.Transform.Projection = Value
        Return True
    End Function

    Public Function GetWorldMatrix(ByRef Value As Matrix) As Boolean
        If mblnHasBeenInit = False Then Return False
        Value = mobjDevice.Transform.World
        Return True
    End Function

    Public Function GetViewMatrix(ByRef Value As Matrix) As Boolean
        If mblnHasBeenInit = False Then Return False
        Value = mobjDevice.Transform.View
        Return True
    End Function

    Public Function GetProjectionMatrix(ByRef Value As Matrix) As Boolean
        If mblnHasBeenInit = False Then Return False
        Value = mobjDevice.Transform.Projection
        Return True
    End Function
End Module
