'Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: January 13, 2003
'=============================================

Imports Microsoft.DirectX.Direct3D.Geometry


''' <summary>
''' The gneral helpers module contains a number of helper methods to assist the developer.
''' </summary>
Public Module GeneralHelpers

#Region " BlendColor overloads ... "
    Public Function BlendColor(ByVal C1 As Color, ByVal C2 As Color, ByVal t As Single) As Color
        Return Color.FromArgb(Blend(C1.A, C2.A, t), Blend(C1.R, C2.R, t), Blend(C1.G, C2.G, t), Blend(C1.B, C2.B, t))
    End Function

    Public Function BlendColor(ByVal C1 As Integer, ByVal C2 As Integer, ByVal t As Single) As Color
        Return BlendColor(Color.FromArgb(C1), Color.FromArgb(C2), t) ' Color.FromArgb(BlendColor(CA.A, Cb.A, t), BlendColor(CA.R, Cb.R, t), BlendColor(CA.G, Cb.G, t), BlendColor(CA.B, Cb.B, t))
    End Function

    Private Function Blend(ByVal C1 As Integer, ByVal C2 As Integer, ByVal t As Single) As Integer
        Return CInt(C1 + (t * (C2 - C1)))
    End Function

    'Private Shared Function BlendColor(ByVal X1 As Single, ByVal X2 As Single, ByVal t As Single) As Single
    '    Return X1 + (t * (X2 - X1))
    'End Function
#End Region



    '#Region " DrawGraphicFont overloads ... "
    '    Public Shared Sub DrawGraphicFont(ByVal Device As Direct3D.Device, ByVal F As D3DGraphicFont, ByVal Text As String, _
    '    ByVal Location As PointF, _
    '    Optional ByVal Textures As Collections.TextureCollection = Nothing, Optional ByVal Callback As RequestTexture = Nothing)
    '        DrawGraphicFont(Device, F, Text, Location.X, Location.Y, Textures, Callback)
    '    End Sub

    '    Public Shared Sub DrawGraphicFont(ByVal Device As Direct3D.Device, ByVal F As D3DGraphicFont, ByVal Text As String, _
    '    ByVal Location As PointF, ByVal Sprite As Direct3D.Sprite, _
    '    Optional ByVal Textures As Collections.TextureCollection = Nothing, Optional ByVal Callback As RequestTexture = Nothing)
    '        DrawGraphicFont(Device, F, Text, Location.X, Location.Y, Sprite, Textures, Callback)
    '    End Sub

    '    Public Shared Sub DrawGraphicFont(ByVal Device As Direct3D.Device, ByVal F As D3DGraphicFont, ByVal Text As String, _
    '    ByVal Location As Point, _
    '    Optional ByVal Textures As Collections.TextureCollection = Nothing, Optional ByVal Callback As RequestTexture = Nothing)
    '        DrawGraphicFont(Device, F, Text, Location.X, Location.Y, Textures, Callback)
    '    End Sub

    '    Public Shared Sub DrawGraphicFont(ByVal Device As Direct3D.Device, ByVal F As D3DGraphicFont, ByVal Text As String, _
    '    ByVal Location As Point, ByVal Sprite As Direct3D.Sprite, _
    '    Optional ByVal Textures As Collections.TextureCollection = Nothing, Optional ByVal Callback As RequestTexture = Nothing)
    '        DrawGraphicFont(Device, F, Text, Location.X, Location.Y, Sprite, Textures, Callback)
    '    End Sub

    '    Public Shared Sub DrawGraphicFont(ByVal Device As Direct3D.Device, ByVal F As D3DGraphicFont, ByVal Text As String, _
    '    ByVal Location As Vector2, _
    '    Optional ByVal Textures As Collections.TextureCollection = Nothing, Optional ByVal Callback As RequestTexture = Nothing)
    '        DrawGraphicFont(Device, F, Text, Location.X, Location.Y, Textures, Callback)
    '    End Sub

    '    Public Shared Sub DrawGraphicFont(ByVal Device As Direct3D.Device, ByVal F As D3DGraphicFont, ByVal Text As String, _
    '    ByVal Location As Vector2, ByVal Sprite As Direct3D.Sprite, _
    '    Optional ByVal Textures As Collections.TextureCollection = Nothing, Optional ByVal Callback As RequestTexture = Nothing)
    '        DrawGraphicFont(Device, F, Text, Location.X, Location.Y, Sprite, Textures, Callback)
    '    End Sub

    '    Public Shared Sub DrawGraphicFont(ByVal Device As Direct3D.Device, ByVal F As D3DGraphicFont, ByVal Text As String, _
    '    ByVal X As Single, ByVal Y As Single, _
    '    Optional ByVal Textures As Collections.TextureCollection = Nothing, Optional ByVal Callback As RequestTexture = Nothing)
    '        Dim S As New Direct3D.Sprite(Device)
    '        DrawGraphicFont(Device, F, Text, X, Y, S, Textures, Callback)
    '        S.Dispose()
    '        S = Nothing
    '    End Sub

    '    ''' <summary>
    '    ''' Draws a graphic font.
    '    ''' </summary>
    '    ''' <param name="Device">A reference to a D3D device object.</param>
    '    ''' <param name="F">A reference to a graphic font.</param>
    '    ''' <param name="Text">The text to be rendered.</param>
    '    ''' <param name="X">The X location on screen to render the text.</param>
    '    ''' <param name="Y">The Y location on screen to render the text.</param>
    '    ''' <param name="Sprite">A reference to a sprite object that will be used to render the text.</param>
    '    ''' <param name="Textures">A reference to a texture collection contating the texture that contains the font characters.</param>
    '    ''' <param name="Callback">A reference to a callback method that will return a texture contating the font characters.</param>
    '    Public Shared Sub DrawGraphicFont(ByVal Device As Direct3D.Device, ByVal F As D3DGraphicFont, ByVal Text As String, _
    '    ByVal X As Single, ByVal Y As Single, ByVal Sprite As Direct3D.Sprite, _
    '    Optional ByVal Textures As Collections.TextureCollection = Nothing, Optional ByVal Callback As RequestTexture = Nothing)
    '        Dim idx, MaxHeight As Integer
    '        Dim V As Vector2 = New Vector2(X, Y)
    '        Dim R As Rectangle
    '        Dim C As String
    '        Dim Tex As Direct3D.Texture


    '        ' set texture to device is ...
    '        If F.UseTextureIndex Then
    '            If Not Textures Is Nothing Then
    '                ' set texture
    '                Tex = Textures(F.TextureIndex)

    '            ElseIf Not Callback Is Nothing Then
    '                ' set texture
    '                Tex = Callback(F.TextureIndex)

    '            Else
    '                ' do nothing
    '            End If
    '        Else
    '            Tex = F.Texture
    '        End If

    '        ' no need to render if texture is nothing
    '        If Tex Is Nothing Then Exit Sub

    '        ' draw text
    '        idx = 0
    '        While idx < Text.Length
    '            C = Text.Chars(idx)
    '            If C = vbCr Then
    '                If idx < 255 Then
    '                    ' skip passed any line feeds if it fallows a carrage return
    '                    If Text.Chars(idx + 1) = vbLf Then idx += 1
    '                End If

    '                V.X = X
    '                V.Y += MaxHeight
    '                'V = New Vector2(X, V.Y + MaxHeight)
    '                MaxHeight = 0

    '            ElseIf C = Space(1) Then
    '                R = F.Chars(Asc(C))
    '                V.X += R.Width - R.Left

    '            Else
    '                R = F.Chars(Asc(C))
    '                If MaxHeight < (R.Height - R.Top) Then MaxHeight = (R.Height - R.Top)
    '                Sprite.Draw(Tex, R, New Vector2(1, 1), New Vector2(), 0, V, Color.White)
    '                V.X += R.Width - R.Left

    '            End If

    '            idx += 1
    '        End While
    '    End Sub
    '#End Region


    '''' <summary>
    '''' Returns the dimentions of the texture.
    '''' </summary>
    '''' <param name="Texture">A reference to a Direct3D.Texture object type.</param>
    '''' <returns>Returns the dimentions of the texture.</returns>
    '''' <remarks>If the Texture parameter is nothing then GetTextureSize will return nothing.</remarks>
    'Public Function GetTextureSize(ByVal Texture As Direct3D.Texture) As Size
    '    If Texture Is Nothing Then Return Nothing
    '    Return New Size(Texture.GetLevelDescription(0).Width, Texture.GetLevelDescription(0).Height)
    'End Function

    '''' <summary>
    '''' Converts Milliseconds into Ticks. Uses the fallowing formula "Milliseconds * TicksPerMilli".
    '''' </summary>
    '''' <param name="Milliseconds">The number of Milliseconds to convert to ticks.</param>
    '''' <returns>Returns the converted result.</returns>
    'Public Function MilliToTicks(ByVal Milliseconds As Long) As Long
    '    Return Milliseconds * Varibles.TicksPerMilli
    'End Function

    '''' <summary>
    '''' Converts Ticks into Milliseconds. Uses the fallowing formula "Ticks \ TicksPerMilli".
    '''' </summary>
    '''' <param name="Ticks">The number of Ticks to convert to Milliseconds.</param>
    '''' <returns>Returns the converted result.</returns>
    'Public Function TicksToMilli(ByVal Ticks As Long) As Long
    '    Return Ticks \ Varibles.TicksPerMilli
    'End Function

    '''' <summary>
    '''' Renders geometry stored in a object that implements a IGeometry interface.
    '''' </summary>
    '''' <param name="Device">A reference to a D3D device object type.</param>
    '''' <param name="Geo">A object that implements a IGeometry interface.</param>
    '''' <param name="Textures">A reference to a TextureCollection object.</param>
    '''' <param name="Callback">A reference to a RequestTexture delegate.</param>
    'Public Shared Sub RenderGeometry(ByVal Device As Direct3D.Device, ByVal Geo As Interfaces.IGeometry, _
    'Optional ByVal Textures As Collections.TextureCollection = Nothing, Optional ByVal Callback As RequestTexture = Nothing)

    '    If TypeOf Geo Is Interfaces.IGeometryWithTextureBlending Then
    '        Dim Blending As BaseTextureBlendingItem

    '        Blending = DirectCast(Geo, Interfaces.IGeometryWithTextureBlending).Blending

    '        ' validate varibles and don't render if either one of them is nothing 
    '        If Blending Is Nothing Then
    '            ' set texture
    '            Device.SetTexture(0, Nothing)
    '        Else

    '            If TypeOf Blending Is TextureBlendingItem Then
    '                ' set texture
    '                Device.SetTexture(0, DirectCast(Blending, TextureBlendingItem).mobjTexture)

    '            ElseIf TypeOf Blending Is IndexedTextureBlendingItem Then
    '                Dim Index As Integer = DirectCast(Blending, IndexedTextureBlendingItem).mintTextureIndex

    '                If Not Textures Is Nothing Then
    '                    ' set texture
    '                    Device.SetTexture(0, Textures(Index))

    '                ElseIf Not Callback Is Nothing Then
    '                    ' set texture
    '                    Device.SetTexture(0, Callback(Index))

    '                Else
    '                    ' set texture
    '                    Device.SetTexture(0, Nothing)
    '                End If

    '            ElseIf TypeOf Blending Is BaseTextureBlendingItem Then
    '                ' set texture
    '                Device.SetTexture(0, Nothing)

    '            Else
    '                ' unknown inherited object type so do nothing
    '            End If

    '            ' set texture blending state is availible
    '            If Not Blending.mobjState Is Nothing Then Device.TextureState(0).FromTextureState(Blending.mobjState)
    '        End If
    '    End If

    '    ' set vert format
    '    Device.VertexFormat = Geo.Format
    '    ' render verts
    '    Device.DrawUserPrimitives(Geo.PrimitiveType, GeneralHelpers.GetPrimitiveCount(Geo), Geo.GetVertexes)
    'End Sub

#Region " GetPrimitiveCount overloads ... "
    ''' <summary>
    ''' Calculates the number os primitives there are for the specified number of verts.
    ''' </summary>
    ''' <param name="pType">Specifies the way the vertexs are stored.</param>
    ''' <param name="VertCount">Specifies the number of vertices.</param>
    ''' <returns>Returns the number of primitives that can be drawn. If returns 0 then VertCount was not high enough.</returns>
    Public Function GetPrimitiveCount(ByVal pType As Direct3D.PrimitiveType, ByVal VertCount As Integer) As Integer
        Select Case pType
            Case Direct3D.PrimitiveType.PointList
                Return VertCount

            Case Direct3D.PrimitiveType.LineStrip, Direct3D.PrimitiveType.LineList
                If VertCount < 2 Then Return 0 Else Return VertCount - 1

            Case Direct3D.PrimitiveType.TriangleList
                If VertCount < 3 Then Return 0 Else Return VertCount \ 3

            Case Direct3D.PrimitiveType.TriangleStrip, Direct3D.PrimitiveType.TriangleFan
                If VertCount < 3 Then Return 0 Else Return VertCount - 2
        End Select
    End Function

    '''' <summary>
    '''' Calculates the number os primitives there are in a object implementing the IGeometry interface type.
    '''' </summary>
    '''' <param name="Geo">Specifies a reference to a object implementing the IGeometry interface type.</param>
    '''' <returns>Returns the number of primitives that can be drawn. If returns 0 then VertCount was not high enough or Geo is nothing.</returns>
    'Public Function GetPrimitiveCount(ByVal Geo As Interfaces.IGeometry) As Integer
    '    If Geo Is Nothing Then Return 0
    '    Return GetPrimitiveCount(Geo.PrimitiveType, Geo.VertexCount)
    'End Function
#End Region

    '#Region " Save/Load Texture state methods ..."
    '    ''' <summary>
    '    ''' Saves the states of a Direct3D.TextureStates type to a file.
    '    ''' </summary>
    '    ''' <param name="File">The name of the file to save to.</param>
    '    ''' <param name="States">A reference to a Direct3D.TextureStates type.</param>
    '    Public Shared Sub SaveTextureStates(ByVal File As String, ByVal States As Direct3D.TextureStates)
    '        Dim idx As Integer

    '        If IO.File.Exists(File) Then IO.File.Delete(File)
    '        For idx = 0 To 7
    '            SetINIData(File, "Header", "Stage" & idx.ToString, "True")
    '            PrivateSaveTextureState(File, idx, States(idx))
    '        Next
    '    End Sub

    '    ''' <summary>
    '    ''' Saves the states of a Direct3D.TextureStates type to a file.
    '    ''' </summary>
    '    ''' <param name="File">The name of the file to save to.</param>
    '    ''' <param name="Stage">The texture stage to be saved.</param>
    '    ''' <param name="State">The Direct3D.TextureState type to save.</param>
    '    Public Shared Sub SaveTextureState(ByVal File As String, ByVal Stage As Integer, ByVal State As Direct3D.TextureState)
    '        Dim idx As Integer


    '        If IO.File.Exists(File) Then IO.File.Delete(File)

    '        For idx = 0 To 7
    '            If Stage = idx Then
    '                SetINIData(File, "Header", "Stage" & idx.ToString, "True")
    '            Else
    '                SetINIData(File, "Header", "Stage" & idx.ToString, "False")
    '            End If
    '        Next

    '        PrivateSaveTextureState(File, Stage, State)
    '    End Sub

    '    ''' <summary>
    '    ''' Loads the states of a Direct3D.TextureStates type from a file.
    '    ''' </summary>
    '    ''' <param name="File">The name of the file to load from.</param>
    '    ''' <param name="Stage">The texture stage to be loaded.</param>
    '    ''' <returns>Returns a Direct3D.TextureState type.</returns>
    '    Public Function LoadTextureState(ByVal File As String, ByVal Stage As Integer) As Direct3D.TextureState
    '        Dim idx As Integer
    '        Dim State As Direct3D.TextureState
    '        Dim A, R, G, B As Integer

    '        State = New Direct3D.TextureState()

    '        If Not CBool(GetINIData(File, "Header", "Stage" & Stage.ToString)) Then Return Nothing


    '        State.AlphaArgument0 = CType(CInt(GetINIData(File, "Header", Stage.ToString & ":" & "AlphaArgument0")), Direct3D.TextureArgument)
    '        State.AlphaArgument1 = CType(CInt(GetINIData(File, "Header", Stage.ToString & ":" & "AlphaArgument1")), Direct3D.TextureArgument)
    '        State.AlphaArgument2 = CType(CInt(GetINIData(File, "Header", Stage.ToString & ":" & "AlphaArgument2")), Direct3D.TextureArgument)
    '        State.AlphaOperation = CType(CInt(GetINIData(File, "Header", Stage.ToString & ":" & "AlphaOperation")), Direct3D.TextureOperation)
    '        State.BumpEnvironmentLuminanceOffset = CSng(GetINIData(File, "Header", Stage.ToString & ":" & "BumpEnvironmentLuminanceOffset"))
    '        State.BumpEnvironmentLuminanceScale = CSng(GetINIData(File, "Header", Stage.ToString & ":" & "BumpEnvironmentLuminanceScale"))
    '        State.BumpEnvironmentMaterial00 = CSng(GetINIData(File, "Header", Stage.ToString & ":" & "BumpEnvironmentMaterial00"))
    '        State.BumpEnvironmentMaterial01 = CSng(GetINIData(File, "Header", Stage.ToString & ":" & "BumpEnvironmentMaterial01"))
    '        State.BumpEnvironmentMaterial10 = CSng(GetINIData(File, "Header", Stage.ToString & ":" & "BumpEnvironmentMaterial10"))
    '        State.BumpEnvironmentMaterial11 = CSng(GetINIData(File, "Header", Stage.ToString & ":" & "BumpEnvironmentMaterial11"))
    '        State.ColorArgument0 = CType(CInt(GetINIData(File, "Header", Stage.ToString & ":" & "ColorArgument0")), Direct3D.TextureArgument)
    '        State.ColorArgument1 = CType(CInt(GetINIData(File, "Header", Stage.ToString & ":" & "ColorArgument1")), Direct3D.TextureArgument)
    '        State.ColorArgument2 = CType(CInt(GetINIData(File, "Header", Stage.ToString & ":" & "ColorArgument2")), Direct3D.TextureArgument)
    '        State.ColorOperation = CType(CInt(GetINIData(File, "Header", Stage.ToString & ":" & "ColorOperation")), Direct3D.TextureOperation)
    '        A = CInt(GetINIData(File, "Header", Stage.ToString & ":" & "ConstantColorA"))
    '        R = CInt(GetINIData(File, "Header", Stage.ToString & ":" & "ConstantColorR"))
    '        G = CInt(GetINIData(File, "Header", Stage.ToString & ":" & "ConstantColorG"))
    '        B = CInt(GetINIData(File, "Header", Stage.ToString & ":" & "ConstantColorB"))
    '        State.ConstantColor = Color.FromArgb(A, R, G, B)
    '        State.ResultArgument = CType(CInt(GetINIData(File, "Header", Stage.ToString & ":" & "ResultArgument")), Direct3D.TextureArgument)
    '        State.TextureCoordinateIndex = CInt(GetINIData(File, "Header", Stage.ToString & ":" & "TextureCoordinateIndex"))
    '        State.TextureTransform = CType(CInt(GetINIData(File, "Header", Stage.ToString & ":" & "TextureTransform")), Direct3D.TextureTransform)

    '        Return State
    '    End Function
    '#End Region

    '#Region " RenderMeshBruteForce overloads ... "

    '    ''' <summary>
    '    ''' Renders a mesh using a brute force method. No optimization. 
    '    ''' </summary>
    '    ''' <param name="Item">The mesh to be rendered.</param>
    '    Public Shared Sub RenderMeshBruteForce(ByVal Item As MeshEx)
    '        Dim idx As Integer
    '        Dim Mat As MaterialTextureCombo

    '        With Item
    '            For idx = 0 To .Materials.Count - 1
    '                Mat = .Materials(idx)
    '                Item.Mesh.Device.Material = Mat.Material
    '                Dim idy As Integer
    '                For idy = 0 To 7
    '                    Item.Mesh.Device.SetTexture(idy, Nothing)
    '                Next

    '                .Mesh.DrawSubset(idx)
    '            Next
    '        End With
    '    End Sub

    '    ''' <summary>
    '    ''' Renders a mesh using a brute force method. No optimization. 
    '    ''' </summary>
    '    ''' <param name="Item">The mesh to be rendered.</param>
    '    ''' <param name="Textures">A reference to a collection containing the textures that this mesh uses.</param>
    '    Public Shared Sub RenderMeshBruteForce(ByVal Item As MeshEx, ByVal Textures As Collections.SimpleTextureCollection)
    '        Dim idx As Integer
    '        Dim Mat As MaterialTextureCombo

    '        With Item
    '            For idx = 0 To .Materials.Count - 1
    '                Mat = .Materials(idx)
    '                Item.Mesh.Device.Material = Mat.Material

    '                Dim idy As Integer
    '                For idy = 0 To 7
    '                    If Mat.Textures(idy) <> -1 And Not Textures Is Nothing Then
    '                        Item.Mesh.Device.SetTexture(idy, Textures(Mat.Textures(idy)))
    '                    Else
    '                        Item.Mesh.Device.SetTexture(idy, Nothing)
    '                    End If
    '                Next

    '                .Mesh.DrawSubset(idx)
    '            Next
    '        End With
    '    End Sub

    '    ''' <summary>
    '    ''' Renders a mesh using a brute force method. No optimization. 
    '    ''' </summary>
    '    ''' <param name="Item">The mesh to be rendered.</param>
    '    ''' <param name="Textures">A reference to a collection containing the textures that this mesh uses.</param>
    '    Public Shared Sub RenderMeshBruteForce(ByVal Item As MeshEx, ByVal Textures As Collections.TextureCollection)
    '        Dim idx As Integer
    '        Dim Mat As MaterialTextureCombo

    '        With Item
    '            For idx = 0 To .Materials.Count - 1
    '                Mat = .Materials(idx)
    '                Item.Mesh.Device.Material = Mat.Material

    '                Dim idy As Integer
    '                For idy = 0 To 7
    '                    If Mat.Textures(idy) <> -1 And Not Textures Is Nothing Then
    '                        Item.Mesh.Device.SetTexture(idy, Textures(Mat.Textures(idy)))
    '                    Else
    '                        Item.Mesh.Device.SetTexture(idy, Nothing)
    '                    End If
    '                Next

    '                .Mesh.DrawSubset(idx)
    '            Next
    '        End With
    '    End Sub
    '#End Region

    '#Region " RemoveTextureIndexes overloads ... "
    '    'TODO: add more RemoveTextureIndexes overloads

    '    ''' <summary>
    '    ''' Sets all of the texture indexs for all the texture stages to -1.
    '    ''' </summary>
    '    ''' <param name="Mat">A MaterialTextureCombo type representing the material to clear.</param>
    '    Public Shared Sub RemoveTextureIndexes(ByVal Mat As MaterialTextureCombo)
    '        With Mat
    '            .Textures(TextureStage.Texture0) = -1
    '            .Textures(TextureStage.Texture1) = -1
    '            .Textures(TextureStage.Texture2) = -1
    '            .Textures(TextureStage.Texture3) = -1
    '            .Textures(TextureStage.Texture4) = -1
    '            .Textures(TextureStage.Texture5) = -1
    '            .Textures(TextureStage.Texture6) = -1
    '            .Textures(TextureStage.Texture7) = -1
    '        End With
    '    End Sub
    '#End Region

#Region " UVFromRectangle overloads ... "
    'TODO add more UVFromRectangle oberloads ?
    'ERR possible stack overflow error with these overloads check and tripple check them


    ''' <summary>
    ''' Converts a rectangle into an array of 4 texture coordanants.
    ''' </summary>
    ''' <param name="ImageWidth">The width of the image.</param>
    ''' <param name="ImageHeight">The height of the image.</param>
    ''' <param name="Left">The left location inside the image.</param>
    ''' <param name="Top">The top location inside the image.</param>
    ''' <param name="Right">The right location inside the image.</param>
    ''' <param name="Bottom">The bottom location inside the image.</param>
    ''' <returns>Returns an array of 4 Vector2 types representing the converted values.</returns>
    Public Function UVFromRectangle(ByVal ImageWidth As Single, ByVal ImageHeight As Single, _
                                    ByVal Left As Single, ByVal Top As Single, _
                                    ByVal Right As Single, ByVal Bottom As Single) As Vector2()

        Dim objTmp(3) As Vector2

        objTmp(0) = UVFromPoint(ImageWidth, ImageHeight, Left, Bottom)    ' top left
        objTmp(1) = UVFromPoint(ImageWidth, ImageHeight, Right, Bottom)   ' top right
        objTmp(3) = UVFromPoint(ImageWidth, ImageHeight, Left, Top)       ' bottom right
        objTmp(2) = UVFromPoint(ImageWidth, ImageHeight, Right, Top)      ' bottom left

        Return objTmp
    End Function

    ''' <summary>
    ''' Converts a rectangle into an array of 4 texture coordanants.
    ''' </summary>
    ''' <param name="ImageWidth">The width of the image.</param>
    ''' <param name="ImageHeight">The height of the image.</param>
    ''' <param name="Left">The left location inside the image.</param>
    ''' <param name="Top">The top location inside the image.</param>
    ''' <param name="Right">The right location inside the image.</param>
    ''' <param name="Bottom">The bottom location inside the image.</param>
    ''' <returns>Returns an array of 4 Vector2 types representing the converted values.</returns>
    Public Function UVFromRectangle(ByVal ImageWidth As Integer, ByVal ImageHeight As Integer, _
                                    ByVal Left As Integer, ByVal Top As Integer, _
                                    ByVal Right As Integer, ByVal Bottom As Integer) As Vector2()

        Return UVFromRectangle(New SizeF(ImageWidth, ImageHeight), Left, Top, Right, Bottom)
    End Function

    ''' <summary>
    ''' Converts a rectangle into an array of 4 texture coordanants.
    ''' </summary>
    ''' <param name="ImageSize">The size of the image.</param>
    ''' <param name="Left">The left location inside the image.</param>
    ''' <param name="Top">The top location inside the image.</param>
    ''' <param name="Right">The right location inside the image.</param>
    ''' <param name="Bottom">The bottom location inside the image.</param>
    ''' <returns>Returns an array of 4 Vector2 types representing the converted values.</returns>
    Public Function UVFromRectangle(ByVal ImageSize As Size, _
                                    ByVal Left As Single, ByVal Top As Single, _
                                    ByVal Right As Single, ByVal Bottom As Single) As Vector2()

        Return UVFromRectangle(ImageSize.Width, ImageSize.Height, Left, Top, Right, Bottom)
    End Function

    ''' <summary>
    ''' Converts a rectangle into an array of 4 texture coordanants.
    ''' </summary>
    ''' <param name="ImageSize">The size of the image.</param>
    ''' <param name="Left">The left location inside the image.</param>
    ''' <param name="Top">The top location inside the image.</param>
    ''' <param name="Right">The right location inside the image.</param>
    ''' <param name="Bottom">The bottom location inside the image.</param>
    ''' <returns>Returns an array of 4 Vector2 types representing the converted values.</returns>
    Public Function UVFromRectangle(ByVal ImageSize As SizeF, _
                                    ByVal Left As Single, ByVal Top As Single, _
                                    ByVal Right As Single, ByVal Bottom As Single) As Vector2()

        Return UVFromRectangle(ImageSize.Width, ImageSize.Height, Left, Top, Right, Bottom)
    End Function

    ''' <summary>
    ''' Converts a rectangle into an array of 4 texture coordanants.
    ''' </summary>
    ''' <param name="ImageSize">The size of the image.</param>
    ''' <param name="Left">The left location inside the image.</param>
    ''' <param name="Top">The top location inside the image.</param>
    ''' <param name="Right">The right location inside the image.</param>
    ''' <param name="Bottom">The bottom location inside the image.</param>
    ''' <returns>Returns an array of 4 Vector2 types representing the converted values.</returns>
    Public Function UVFromRectangle(ByVal ImageSize As Size, _
                                    ByVal Left As Integer, ByVal Top As Integer, _
                                    ByVal Right As Integer, ByVal Bottom As Integer) As Vector2()

        Return UVFromRectangle(ImageSize.Width, ImageSize.Height, Left, Top, Right, Bottom)
    End Function

    ''' <summary>
    ''' Converts a rectangle into an array of 4 texture coordanants.
    ''' </summary>
    ''' <param name="ImageSize">The size of the image.</param>
    ''' <param name="Left">The left location inside the image.</param>
    ''' <param name="Top">The top location inside the image.</param>
    ''' <param name="Right">The right location inside the image.</param>
    ''' <param name="Bottom">The bottom location inside the image.</param>
    ''' <returns>Returns an array of 4 Vector2 types representing the converted values.</returns>
    Public Function UVFromRectangle(ByVal ImageSize As SizeF, _
                                 ByVal Left As Integer, ByVal Top As Integer, _
                                 ByVal Right As Integer, ByVal Bottom As Integer) As Vector2()

        Return UVFromRectangle(ImageSize.Width, ImageSize.Height, Left, Top, Right, Bottom)
    End Function

    ''' <summary>
    ''' Converts a rectangle into an array of 4 texture coordanants.
    ''' </summary>
    ''' <param name="ImageSize">The size of the image.</param>
    ''' <param name="R">The source rectangle to convert.</param>
    ''' <returns>Returns an array of 4 Vector2 types representing the converted values.</returns>
    Public Function UVFromRectangle(ByVal ImageSize As Size, ByVal R As Rectangle) As Vector2()
        Return UVFromRectangle(ImageSize.Width, ImageSize.Height, R.Left, R.Top, R.Right, R.Bottom)
    End Function

    ''' <summary>
    ''' Converts a rectangle into an array of 4 texture coordanants.
    ''' </summary>
    ''' <param name="ImageSize">The size of the image.</param>
    ''' <param name="R">The source rectangle to convert.</param>
    ''' <returns>Returns an array of 4 Vector2 types representing the converted values.</returns>
    Public Function UVFromRectangle(ByVal ImageSize As SizeF, ByVal R As Rectangle) As Vector2()
        Return UVFromRectangle(ImageSize.Width, ImageSize.Height, R.Left, R.Top, R.Right, R.Bottom)
    End Function

    ''' <summary>
    ''' Converts a rectangle into an array of 4 texture coordanants.
    ''' </summary>
    ''' <param name="ImageSize">The size of the image.</param>
    ''' <param name="R">The source rectangle to convert.</param>
    ''' <returns>Returns an array of 4 Vector2 types representing the converted values.</returns>
    Public Function UVFromRectangle(ByVal ImageSize As Size, ByVal R As RectangleF) As Vector2()
        Return UVFromRectangle(ImageSize.Width, ImageSize.Height, R.Left, R.Top, R.Right, R.Bottom)
    End Function

    ''' <summary>
    ''' Converts a rectangle into an array of 4 texture coordanants.
    ''' </summary>
    ''' <param name="ImageSize">The size of the image.</param>
    ''' <param name="R">The source rectangle to convert.</param>
    ''' <returns>Returns an array of 4 Vector2 types representing the converted values.</returns>
    Public Function UVFromRectangle(ByVal ImageSize As SizeF, ByVal R As RectangleF) As Vector2()
        Return UVFromRectangle(ImageSize.Width, ImageSize.Height, R.Left, R.Top, R.Right, R.Bottom)
    End Function

    ''' <summary>
    ''' Converts a rectangle into an array of 4 texture coordanants.
    ''' </summary>
    ''' <param name="ImageSize">The size of the image.</param>
    ''' <param name="Location">The location representing the top left of the source rectangle to convert.</param>
    ''' <param name="Size">The location representing the size of the source rectangle to convert.</param>
    ''' <returns>Returns an array of 4 Vector2 types representing the converted values.</returns>
    Public Function UVFromRectangle(ByVal ImageSize As Size, ByVal Location As Point, ByVal Size As Size) As Vector2()
        Return UVFromRectangle(ImageSize.Width, ImageSize.Height, Location.X, Location.Y, _
                               Location.X + Size.Width, Location.Y + Size.Height)
    End Function

    ''' <summary>
    ''' Converts a rectangle into an array of 4 texture coordanants.
    ''' </summary>
    ''' <param name="ImageSize">The size of the image.</param>
    ''' <param name="Location">The location representing the top left of the source rectangle to convert.</param>
    ''' <param name="Size">The location representing the size of the source rectangle to convert.</param>
    ''' <returns>Returns an array of 4 Vector2 types representing the converted values.</returns>
    Public Function UVFromRectangle(ByVal ImageSize As Size, ByVal Location As PointF, ByVal Size As Size) As Vector2()
        Return UVFromRectangle(ImageSize.Width, ImageSize.Height, Location.X, Location.Y, _
                               Location.X + Size.Width, Location.Y + Size.Height)
    End Function

    ''' <summary>
    ''' Converts a rectangle into an array of 4 texture coordanants.
    ''' </summary>
    ''' <param name="ImageSize">The size of the image.</param>
    ''' <param name="Location">The location representing the top left of the source rectangle to convert.</param>
    ''' <param name="Size">The location representing the size of the source rectangle to convert.</param>
    ''' <returns>Returns an array of 4 Vector2 types representing the converted values.</returns>
    Public Function UVFromRectangle(ByVal ImageSize As Size, ByVal Location As Point, ByVal Size As SizeF) As Vector2()
        Return UVFromRectangle(ImageSize.Width, ImageSize.Height, Location.X, Location.Y, _
                               Location.X + Size.Width, Location.Y + Size.Height)
    End Function

    ''' <summary>
    ''' Converts a rectangle into an array of 4 texture coordanants.
    ''' </summary>
    ''' <param name="ImageSize">The size of the image.</param>
    ''' <param name="Location">The location representing the top left of the source rectangle to convert.</param>
    ''' <param name="Size">The location representing the size of the source rectangle to convert.</param>
    ''' <returns>Returns an array of 4 Vector2 types representing the converted values.</returns>
    Public Function UVFromRectangle(ByVal ImageSize As Size, ByVal Location As PointF, ByVal Size As SizeF) As Vector2()
        Return UVFromRectangle(ImageSize.Width, ImageSize.Height, Location.X, Location.Y, _
                               Location.X + Size.Width, Location.Y + Size.Height)
    End Function

    ''' <summary>
    ''' Converts a rectangle into an array of 4 texture coordanants.
    ''' </summary>
    ''' <param name="ImageSize">The size of the image.</param>
    ''' <param name="Location">The location representing the top left of the source rectangle to convert.</param>
    ''' <param name="Size">The location representing the size of the source rectangle to convert.</param>
    ''' <returns>Returns an array of 4 Vector2 types representing the converted values.</returns>
    Public Function UVFromRectangle(ByVal ImageSize As SizeF, ByVal Location As Point, ByVal Size As Size) As Vector2()
        Return UVFromRectangle(ImageSize.Width, ImageSize.Height, Location.X, Location.Y, _
                               Location.X + Size.Width, Location.Y + Size.Height)
    End Function

    ''' <summary>
    ''' Converts a rectangle into an array of 4 texture coordanants.
    ''' </summary>
    ''' <param name="ImageSize">The size of the image.</param>
    ''' <param name="Location">The location representing the top left of the source rectangle to convert.</param>
    ''' <param name="Size">The location representing the size of the source rectangle to convert.</param>
    ''' <returns>Returns an array of 4 Vector2 types representing the converted values.</returns>
    Public Function UVFromRectangle(ByVal ImageSize As SizeF, ByVal Location As PointF, ByVal Size As Size) As Vector2()
        Return UVFromRectangle(ImageSize.Width, ImageSize.Height, Location.X, Location.Y, _
                               Location.X + Size.Width, Location.Y + Size.Height)
    End Function

    ''' <summary>
    ''' Converts a rectangle into an array of 4 texture coordanants.
    ''' </summary>
    ''' <param name="ImageSize">The size of the image.</param>
    ''' <param name="Location">The location representing the top left of the source rectangle to convert.</param>
    ''' <param name="Size">The location representing the size of the source rectangle to convert.</param>
    ''' <returns>Returns an array of 4 Vector2 types representing the converted values.</returns>
    Public Function UVFromRectangle(ByVal ImageSize As SizeF, ByVal Location As Point, ByVal Size As SizeF) As Vector2()
        Return UVFromRectangle(ImageSize.Width, ImageSize.Height, Location.X, Location.Y, _
                               Location.X + Size.Width, Location.Y + Size.Height)
    End Function

    ''' <summary>
    ''' Converts a rectangle into an array of 4 texture coordanants.
    ''' </summary>
    ''' <param name="ImageSize">The size of the image.</param>
    ''' <param name="Location">The location representing the top left of the source rectangle to convert.</param>
    ''' <param name="Size">The location representing the size of the source rectangle to convert.</param>
    ''' <returns>Returns an array of 4 Vector2 types representing the converted values.</returns>
    Public Function UVFromRectangle(ByVal ImageSize As SizeF, ByVal Location As PointF, ByVal Size As SizeF) As Vector2()
        Return UVFromRectangle(ImageSize.Width, ImageSize.Height, Location.X, Location.Y, _
                               Location.X + Size.Width, Location.Y + Size.Height)
    End Function

#End Region

#Region " UVFromPoint overloads ... "
    'TODO: add more UVFromPoint overloads?
    'ERR: possible stack overflow error with these overloads check and tripple check them

    ''' <summary>
    ''' Converts a X/Y value into a texture coordanant.
    ''' </summary>
    ''' <param name="ImageWidth">The width of the image.</param>
    ''' <param name="ImageHeight">The height of the image.</param>
    ''' <param name="X">The X location inside the image.</param>
    ''' <param name="Y">The Y location inside the image.</param>
    ''' <returns>Returns a Vector2 type representing the converted X/Y value.</returns>
    Public Function UVFromPoint(ByVal ImageWidth As Single, ByVal ImageHeight As Single, ByVal X As Single, ByVal Y As Single) As Vector2
        Dim V As Vector2

        If X = 0 Then V.X = 0 Else V.X = X / ImageWidth
        If Y = 0 Then V.Y = 0 Else V.Y = Y / ImageHeight
        Return V
    End Function

    ''' <summary>
    ''' Converts a X/Y value into a texture coordanant.
    ''' </summary>
    ''' <param name="ImageWidth">The width of the image.</param>
    ''' <param name="ImageHeight">The height of the image.</param>
    ''' <param name="X">The X location inside the image.</param>
    ''' <param name="Y">The Y location inside the image.</param>
    ''' <returns>Returns a Vector2 type representing the converted X/Y value.</returns>
    Public Function UVFromPoint(ByVal ImageWidth As Integer, ByVal ImageHeight As Integer, ByVal X As Integer, ByVal Y As Integer) As Vector2
        Dim V As Vector2

        If X = 0 Then V.X = 0 Else V.X = CSng(X / ImageWidth)
        If Y = 0 Then V.Y = 0 Else V.Y = CSng(Y / ImageHeight)
        Return V
    End Function

    ''' <summary>
    ''' Converts a X/Y value into a texture coordanant.
    ''' </summary>
    ''' <param name="ImageSize">The size of the image.</param>
    ''' <param name="P">The location inside the image.</param>
    ''' <returns>Returns a Vector2 type representing the converted X/Y value.</returns>
    Public Function UVFromPoint(ByVal ImageSize As SizeF, ByVal P As PointF) As Vector2
        Return UVFromPoint(ImageSize.Width, ImageSize.Height, P.X, P.Y)
    End Function

    ''' <summary>
    ''' Converts a X/Y value into a texture coordanant.
    ''' </summary>
    ''' <param name="ImageSize">The size of the image.</param>
    ''' <param name="P">The location inside the image.</param>
    ''' <returns>Returns a Vector2 type representing the converted X/Y value.</returns>
    Public Function UVFromPoint(ByVal ImageSize As Size, ByVal P As PointF) As Vector2
        Return UVFromPoint(ImageSize.Width, ImageSize.Height, P.X, P.Y)
    End Function

    ''' <summary>
    ''' Converts a X/Y value into a texture coordanant.
    ''' </summary>
    ''' <param name="ImageSize">The size of the image.</param>
    ''' <param name="P">The location inside the image.</param>
    ''' <returns>Returns a Vector2 type representing the converted X/Y value.</returns>
    Public Function UVFromPoint(ByVal ImageSize As SizeF, ByVal P As Point) As Vector2
        Return UVFromPoint(ImageSize.Width, ImageSize.Height, P.X, P.Y)
    End Function

    ''' <summary>
    ''' Converts a X/Y value into a texture coordanant.
    ''' </summary>
    ''' <param name="ImageSize">The size of the image.</param>
    ''' <param name="P">The location inside the image.</param>
    ''' <returns>Returns a Vector2 type representing the converted X/Y value.</returns>
    Public Function UVFromPoint(ByVal ImageSize As Size, ByVal P As Point) As Vector2
        Return UVFromPoint(ImageSize.Width, ImageSize.Height, P.X, P.Y)
    End Function
#End Region

#Region " RestrictVector2 overloads ... "
    ' TODO: add more RestrictVector2 overloads.

    ''' <summary>
    ''' Restricts a Vector2 type within a specified region.
    ''' </summary>
    ''' <param name="V">The vector2 type to restrict.</param>
    ''' <param name="R">The rectangle representing the region to restrict the Vector2 type to.</param>
    ''' <returns>Returns the restricted Vector2 type.</returns>
    Public Function RestrictVector2(ByVal V As Vector2, ByVal R As RectangleF) As Vector2
        Dim Tmp As Vector2

        Tmp = V
        If V.X < R.Left Then Tmp.X = R.Left
        If V.X > R.Right Then Tmp.X = R.Right
        If V.Y < R.Top Then Tmp.Y = R.Top
        If V.Y > R.Bottom Then Tmp.Y = R.Bottom

        Return Tmp
    End Function

    ''' <summary>
    ''' Restricts a Vector2 type within a specified region.
    ''' </summary>
    ''' <param name="V">The vector2 type to restrict.</param>
    ''' <param name="R">The rectangle representing the region to restrict the Vector2 type to.</param>
    ''' <returns>Returns the restricted Vector2 type.</returns>
    Public Function RestrictVector2(ByVal V As Vector2, ByVal R As Rectangle) As Vector2
        Dim Tmp As Vector2

        Tmp = V
        If V.X < R.Left Then Tmp.X = R.Left
        If V.X > R.Right Then Tmp.X = R.Right
        If V.Y < R.Top Then Tmp.Y = R.Top
        If V.Y > R.Bottom Then Tmp.Y = R.Bottom

        Return Tmp
    End Function

    ''' <summary>
    ''' Restricts a Vector2 type within a specified region.
    ''' </summary>
    ''' <param name="V">The vector2 type to restrict.</param>
    ''' <param name="L">The location representing the top left region to restrict the Vector2 type to.</param>
    ''' <param name="S">The size of the area relative to the location parameter to restrict the Vector2 type to.</param>
    ''' <returns>Returns the restricted Vector2 type.</returns>
    Public Function RestrictVector2(ByVal V As Vector2, ByVal L As Point, ByVal S As Size) As Vector2
        Dim Tmp As Vector2

        Tmp = V
        If V.X < L.X Then Tmp.X = L.X
        If V.X > L.X + S.Width Then Tmp.X = L.X + S.Width
        If V.Y < L.Y Then Tmp.Y = L.Y
        If V.Y > L.Y + S.Height Then Tmp.Y = L.Y + S.Height

        Return Tmp
    End Function

    ''' <summary>
    ''' Restricts a Vector2 type within a specified region.
    ''' </summary>
    ''' <param name="V">The vector2 type to restrict.</param>
    ''' <param name="L">The location representing the top left region to restrict the Vector2 type to.</param>
    ''' <param name="S">The size of the area relative to the location parameter to restrict the Vector2 type to.</param>
    ''' <returns>Returns the restricted Vector2 type.</returns>
    Public Function RestrictVector2(ByVal V As Vector2, ByVal L As PointF, ByVal S As Size) As Vector2
        Dim Tmp As Vector2

        Tmp = V
        If V.X < L.X Then Tmp.X = L.X
        If V.X > L.X + S.Width Then Tmp.X = L.X + S.Width
        If V.Y < L.Y Then Tmp.Y = L.Y
        If V.Y > L.Y + S.Height Then Tmp.Y = L.Y + S.Height

        Return Tmp
    End Function

    ''' <summary>
    ''' Restricts a Vector2 type within a specified region.
    ''' </summary>
    ''' <param name="V">The vector2 type to restrict.</param>
    ''' <param name="L">The location representing the top left region to restrict the Vector2 type to.</param>
    ''' <param name="S">The size of the area relative to the location parameter to restrict the Vector2 type to.</param>
    ''' <returns>Returns the restricted Vector2 type.</returns>
    Public Function RestrictVector2(ByVal V As Vector2, ByVal L As Point, ByVal S As SizeF) As Vector2
        Dim Tmp As Vector2

        Tmp = V
        If V.X < L.X Then Tmp.X = L.X
        If V.X > L.X + S.Width Then Tmp.X = L.X + S.Width
        If V.Y < L.Y Then Tmp.Y = L.Y
        If V.Y > L.Y + S.Height Then Tmp.Y = L.Y + S.Height

        Return Tmp
    End Function

    ''' <summary>
    ''' Restricts a Vector2 type within a specified region.
    ''' </summary>
    ''' <param name="V">The vector2 type to restrict.</param>
    ''' <param name="L">The location representing the top left region to restrict the Vector2 type to.</param>
    ''' <param name="S">The size of the area relative to the location parameter to restrict the Vector2 type to.</param>
    ''' <returns>Returns the restricted Vector2 type.</returns>
    Public Function RestrictVector2(ByVal V As Vector2, ByVal L As PointF, ByVal S As SizeF) As Vector2
        Dim Tmp As Vector2

        Tmp = V
        If V.X < L.X Then Tmp.X = L.X
        If V.X > L.X + S.Width Then Tmp.X = L.X + S.Width
        If V.Y < L.Y Then Tmp.Y = L.Y
        If V.Y > L.Y + S.Height Then Tmp.Y = L.Y + S.Height

        Return Tmp
    End Function
#End Region

    '#Region " BuildMatrixStack overloads ... "
    '    ''' <summary>
    '    ''' Builds a matrix from a matrix stack.
    '    ''' </summary>
    '    ''' <param name="Stack">A reference to a MatrixStackCollection type.</param>
    '    ''' <param name="InitialState">The initial or starting matrix to use</param>
    '    ''' <returns>Returns the built matrix.</returns>
    '    ''' <exception cref="ArgumentNullException">
    '    '''     Will throw a standard ArgumentNullException Exception if the Stack parameter is nothing.
    '    ''' </exception>
    '    Public Function BuildMatrixStack(ByVal Stack As Collections.MatrixStackCollection, ByVal InitialState As Matrix) As Matrix
    '        Dim M As Matrix = Matrix.Identity
    '        Dim idx As Integer

    '        If Stack Is Nothing Then Throw New ArgumentNullException("Stack")
    '        If Stack.ActualCount = 0 Then Return M

    '        M = InitialState
    '        For idx = 0 To Stack.Count
    '            If Not Stack(idx) Is Nothing Then
    '                With Stack(idx)
    '                    Select Case .Function
    '                        Case MatrixFunction.Add
    '                            M = Matrix.Add(M, .Matrix)

    '                        Case MatrixFunction.Invert
    '                            M = Matrix.Invert(.Matrix)

    '                        Case MatrixFunction.Multiply
    '                            M = Matrix.Multiply(M, .Matrix)

    '                        Case MatrixFunction.MultiplyTranspose
    '                            M = Matrix.MultiplyTranspose(M, .Matrix)

    '                        Case MatrixFunction.Subtract
    '                            M = Matrix.Subtract(M, .Matrix)

    '                    End Select
    '                End With
    '            End If
    '        Next

    '        Return M
    '    End Function

    '    ''' <summary>
    '    ''' Builds a matrix from a matrix stack.
    '    ''' </summary>
    '    ''' <param name="Stack">A reference to a MatrixStackCollection type.</param>
    '    ''' <returns>Returns the built matrix.</returns>
    '    ''' <exception cref="ArgumentNullException">
    '    '''     Will throw a standard ArgumentNullException Exception if the Stack parameter is nothing.
    '    ''' </exception>
    '    Public Function BuildMatrixStack(ByVal Stack As Collections.MatrixStackCollection) As Matrix
    '        Return BuildMatrixStack(Stack, Matrix.Identity)
    '    End Function
    '#End Region

#Region " ModeAvailible overloads ... "
    ''' <summary>
    ''' Used to help determin what display modes are availible.
    ''' </summary>
    ''' <param name="AdapterIndex">The index of the adapter to test.</param>
    ''' <param name="Width">The width of the display mode to test for.</param>
    ''' <param name="Height">The height of the display mode to test for.</param>
    ''' <param name="Format">The display format of the display mode to test for.</param>
    ''' <returns>Returns True if successfull.</returns>
    Public Function ModeAvailible(ByVal AdapterIndex As Integer, ByVal Width As Integer, ByVal Height As Integer, ByVal Format As Direct3D.Format) As Boolean
        Dim Mode As Direct3D.DisplayMode

        With Direct3D.Manager.Adapters.Item(AdapterIndex)
            With .SupportedDisplayModes.Item(Format).GetEnumerator
                .Reset()
                While .MoveNext
                    Mode = CType(.Current, Direct3D.DisplayMode)
                    If Mode.Format = Format And _
                    Mode.Width = Width And _
                    Mode.Height = Height Then
                        Return True
                    End If
                End While
            End With
        End With

        Return False
    End Function

    ''' <summary>
    ''' Used to help determin what display modes are availible.
    ''' </summary>
    ''' <param name="AdapterIndex">The index of the adapter to test.</param>
    ''' <param name="Size">Represents the width and height to test for.</param>
    ''' <param name="Format">The display format of the display mode to test for.</param>
    ''' <returns>Returns True if successfull.</returns>
    Public Function ModeAvailible(ByVal AdapterIndex As Integer, ByVal Size As Size, ByVal Format As Direct3D.Format) As Boolean
        Return ModeAvailible(AdapterIndex, Size.Width, Size.Height, Format)
    End Function

    ''' <summary>
    ''' Used to help determin what display modes are availible.
    ''' </summary>
    ''' <param name="AdapterIndex">The index of the adapter to test.</param>
    ''' <param name="Size">Represents the width and height to test for.</param>
    ''' <param name="Format">The display format of the display mode to test for.</param>
    ''' <returns>Returns True if successfull.</returns>
    Public Function ModeAvailible(ByVal AdapterIndex As Integer, ByVal Size As SizeF, ByVal Format As Direct3D.Format) As Boolean
        Return ModeAvailible(AdapterIndex, CInt(Size.Width), CInt(Size.Height), Format)
    End Function

    ''' <summary>
    ''' Used to help determin what display modes are availible.
    ''' </summary>
    ''' <param name="AdapterIndex">The index of the adapter to test.</param>
    ''' <param name="Width">The width of the display mode to test for.</param>
    ''' <param name="Height">The height of the display mode to test for.</param>
    ''' <param name="BitDepth">The bit depth to test for. Only 16bit or 32bit is allowed otherwise argument exception is raised.</param>
    ''' <returns>Returns True if successfull.</returns>
    Public Function ModeAvailible(ByVal AdapterIndex As Integer, ByVal Width As Integer, ByVal Height As Integer, ByVal BitDepth As Integer) As Boolean
        Select Case BitDepth
            Case 16
                Return ModeAvailible(AdapterIndex, Width, Height, Direct3D.Format.R5G6B5)
            Case 32
                Return ModeAvailible(AdapterIndex, Width, Height, Direct3D.Format.X8R8G8B8)

            Case Else
                Throw New ArgumentException("Bad value passed. Only 16 or 32 is acceptable.", "BitDepth")
        End Select
    End Function

    ''' <summary>
    ''' Used to help determin what display modes are availible.
    ''' </summary>
    ''' <param name="AdapterIndex">The index of the adapter to test.</param>
    ''' <param name="Size">Represents the width and height to test for.</param>
    ''' <param name="BitDepth">The bit depth to test for. Only 16bit or 32bit is allowed otherwise argument exception is raised.</param>
    ''' <returns>Returns True if successfull.</returns>
    Public Function ModeAvailible(ByVal AdapterIndex As Integer, ByVal Size As Size, ByVal BitDepth As Integer) As Boolean
        Select Case BitDepth
            Case 16
                Return ModeAvailible(AdapterIndex, Size.Width, Size.Height, Direct3D.Format.R5G6B5)
            Case 32
                Return ModeAvailible(AdapterIndex, Size.Width, Size.Height, Direct3D.Format.X8R8G8B8)

            Case Else
                Throw New ArgumentException("Bad value passed. Only 16 or 32 is acceptable.", "BitDepth")
        End Select
    End Function

    ''' <summary>
    ''' Used to help determin what display modes are availible.
    ''' </summary>
    ''' <param name="AdapterIndex">The index of the adapter to test.</param>
    ''' <param name="Size">Represents the width and height to test for.</param>
    ''' <param name="BitDepth">The bit depth to test for. Only 16bit or 32bit is allowed otherwise argument exception is raised.</param>
    ''' <returns>Returns True if successfull.</returns>
    Public Function ModeAvailible(ByVal AdapterIndex As Integer, ByVal Size As SizeF, ByVal BitDepth As Integer) As Boolean
        Select Case BitDepth
            Case 16
                Return ModeAvailible(AdapterIndex, CInt(Size.Width), CInt(Size.Height), Direct3D.Format.R5G6B5)
            Case 32
                Return ModeAvailible(AdapterIndex, CInt(Size.Width), CInt(Size.Height), Direct3D.Format.X8R8G8B8)

            Case Else
                Throw New ArgumentException("Bad value passed. Only 16 or 32 is acceptable.", "BitDepth")
        End Select
    End Function

    ''' <summary>
    ''' Used to help determin what display modes are availible.
    ''' </summary>
    ''' <param name="AdapterIndex">The index of the adapter to test.</param>
    ''' <param name="Mode">A Direct3D.DisplayMode type representing the display mode to test for.</param>
    ''' <returns>Returns True if successfull.</returns>
    Public Function ModeAvailible(ByVal AdapterIndex As Integer, ByVal Mode As Direct3D.DisplayMode) As Boolean
        Return ModeAvailible(AdapterIndex, Mode.Width, Mode.Height, Mode.Format)
    End Function

    ''' <summary>
    ''' Checks to see if a specific direct draw display mode is availible.
    ''' </summary>
    ''' <param name="Width">The width of the display mode.</param>
    ''' <param name="Height">The height of the display mode.</param>
    ''' <param name="BitCount">The bitcount of the display mode. For example you would specify 16 for a 16bit color mode etc. </param>
    ''' <returns>Will return True if the mode is available else False if it is not.</returns>
    Public Function ModeAvailible(ByVal Device As DirectDraw.Device, ByVal Width As Integer, ByVal Height As Integer, ByVal BitCount As Integer) As Boolean
        Dim Desc As DirectDraw.SurfaceDescription
        Dim Modes As DirectDraw.DisplayModesCollection


        If Device Is Nothing Then Throw New ArgumentNullException("Device") ' Exceptions.DX9ToolsDDDeviceIsNothing()

        Modes = New DirectDraw.DisplayModesCollection(Device)
        For Each Desc In Modes
            If Desc.Width = Width And Desc.Height = Height Then
                If Desc.PixelFormatStructure.RgbBitCount = BitCount Then Return True
            End If
        Next

        Return False
    End Function
#End Region



    'Public Function LoadTexture(ByVal Device As Direct3D.Device, ByVal TextureCollection As DX9Tools.Collections.TextureCollection, ByVal File As String) As Integer
    '    Dim Tex As Direct3D.Texture

    '    Tex = Direct3D.TextureLoader.FromFile(Device, File, 0, 0, 0, 0, _
    '                                           Direct3D.Format.Unknown, Direct3D.Pool.Managed, _
    '                                           Direct3D.Filter.None, Direct3D.Filter.None, _
    '                                           Color.Black.ToArgb)
    '    Return TextureCollection.Add(Tex)
    'End Function

    'Public Function LoadTexture(ByVal Device As Direct3D.Device, ByVal TextureCollection As DX9Tools.Collections.TextureCollection, ByVal File As String, ByVal ColorKey As Color) As Integer
    '    Dim Tex As Direct3D.Texture

    '    Tex = Direct3D.TextureLoader.FromFile(Device, File, 0, 0, 0, 0, _
    '                                               Direct3D.Format.Unknown, Direct3D.Pool.Managed, _
    '                                               Direct3D.Filter.None, Direct3D.Filter.None, _
    '                                               ColorKey.ToArgb)
    '    Return TextureCollection.Add(Tex)
    'End Function

    'Public Function LoadTexture(ByVal Device As Direct3D.Device, ByVal TextureCollection As DX9Tools.Collections.TextureCollection, ByVal File As String, ByVal Filter As Direct3D.Filter) As Integer
    '    Dim Tex As Direct3D.Texture

    '    Tex = Direct3D.TextureLoader.FromFile(Device, File, 0, 0, 0, 0, _
    '                                               Direct3D.Format.Unknown, Direct3D.Pool.Managed, _
    '                                               Filter, Filter, _
    '                                               Color.Black.ToArgb)
    '    Return TextureCollection.Add(Tex)
    'End Function

    'Public Function LoadTexture(ByVal Device As Direct3D.Device, ByVal TextureCollection As DX9Tools.Collections.TextureCollection, ByVal File As String, ByVal Filter As Direct3D.Filter, ByVal ColorKey As Color) As Integer
    '    Dim Tex As Direct3D.Texture

    '    Tex = Direct3D.TextureLoader.FromFile(Device, File, 0, 0, 0, 0, _
    '                                               Direct3D.Format.Unknown, Direct3D.Pool.Managed, _
    '                                               Filter, Filter, _
    '                                               Color.Black.ToArgb)
    '    Return TextureCollection.Add(Tex)
    'End Function

    'Public Function LoadTexture(ByVal Device As Direct3D.Device, ByVal TextureCollection As DX9Tools.Collections.TextureCollection, ByVal File As String, ByRef Info As Direct3D.ImageInformation) As Integer
    '    Dim Tex As Direct3D.Texture

    '    Tex = Direct3D.TextureLoader.FromFile(Device, File, 0, 0, 0, 0, _
    '                                                Direct3D.Format.Unknown, Direct3D.Pool.Managed, _
    '                                                Direct3D.Filter.None, Direct3D.Filter.None, _
    '                                                Color.Black.ToArgb)
    '    Info = Direct3D.TextureLoader.ImageInformationFromFile(File)
    '    Return TextureCollection.Add(Tex)
    'End Function

    'Public Function LoadTexture(ByVal Device As Direct3D.Device, ByVal TextureCollection As DX9Tools.Collections.TextureCollection, ByVal File As String, ByVal ColorKey As Color, ByRef Info As Direct3D.ImageInformation) As Integer
    '    Dim Tex As Direct3D.Texture

    '    Tex = Direct3D.TextureLoader.FromFile(Device, File, 0, 0, 0, 0, _
    '                                                Direct3D.Format.Unknown, Direct3D.Pool.Managed, _
    '                                                Direct3D.Filter.None, Direct3D.Filter.None, _
    '                                                ColorKey.ToArgb)
    '    Info = Direct3D.TextureLoader.ImageInformationFromFile(File)
    '    Return TextureCollection.Add(Tex)
    'End Function

    'Public Function LoadTexture(ByVal Device As Direct3D.Device, ByVal TextureCollection As DX9Tools.Collections.TextureCollection, ByVal File As String, ByVal Filter As Direct3D.Filter, ByRef Info As Direct3D.ImageInformation) As Integer
    '    Dim Tex As Direct3D.Texture

    '    Tex = Direct3D.TextureLoader.FromFile(Device, File, 0, 0, 0, 0, _
    '                                                  Direct3D.Format.Unknown, Direct3D.Pool.Managed, _
    '                                                  Filter, Filter, _
    '                                                  Color.Black.ToArgb)
    '    Info = Direct3D.TextureLoader.ImageInformationFromFile(File)
    '    Return TextureCollection.Add(Tex)
    'End Function

    'Public Function LoadTexture(ByVal Device As Direct3D.Device, ByVal TextureCollection As DX9Tools.Collections.TextureCollection, ByVal File As String, ByVal Filter As Direct3D.Filter, ByVal ColorKey As Color, ByRef Info As Direct3D.ImageInformation) As Integer
    '    Dim Tex As Direct3D.Texture

    '    Tex = Direct3D.TextureLoader.FromFile(Device, File, 0, 0, 0, 0, _
    '                                                 Direct3D.Format.Unknown, Direct3D.Pool.Managed, _
    '                                                 Filter, Filter, _
    '                                                 Color.Black.ToArgb)
    '    Info = Direct3D.TextureLoader.ImageInformationFromFile(File)
    '    Return TextureCollection.Add(Tex)
    'End Function

    'Public Function LoadTexture(ByVal Device As Direct3D.Device, ByVal TextureCollection As DX9Tools.Collections.SimpleTextureCollection, ByVal File As String) As Integer
    '    Dim Tex As Direct3D.Texture

    '    Tex = Direct3D.TextureLoader.FromFile(Device, File, 0, 0, 0, 0, _
    '                                           Direct3D.Format.Unknown, Direct3D.Pool.Managed, _
    '                                           Direct3D.Filter.None, Direct3D.Filter.None, _
    '                                           Color.Black.ToArgb)
    '    Return TextureCollection.Add(Tex)
    'End Function

    'Public Function LoadTexture(ByVal Device As Direct3D.Device, ByVal TextureCollection As DX9Tools.Collections.SimpleTextureCollection, ByVal File As String, ByVal ColorKey As Color) As Integer
    '    Dim Tex As Direct3D.Texture

    '    Tex = Direct3D.TextureLoader.FromFile(Device, File, 0, 0, 0, 0, _
    '                                               Direct3D.Format.Unknown, Direct3D.Pool.Managed, _
    '                                               Direct3D.Filter.None, Direct3D.Filter.None, _
    '                                               ColorKey.ToArgb)
    '    Return TextureCollection.Add(Tex)
    'End Function

    'Public Function LoadTexture(ByVal Device As Direct3D.Device, ByVal TextureCollection As DX9Tools.Collections.SimpleTextureCollection, ByVal File As String, ByVal Filter As Direct3D.Filter) As Integer
    '    Dim Tex As Direct3D.Texture

    '    Tex = Direct3D.TextureLoader.FromFile(Device, File, 0, 0, 0, 0, _
    '                                               Direct3D.Format.Unknown, Direct3D.Pool.Managed, _
    '                                               Filter, Filter, _
    '                                               Color.Black.ToArgb)
    '    Return TextureCollection.Add(Tex)
    'End Function

    'Public Function LoadTexture(ByVal Device As Direct3D.Device, ByVal TextureCollection As DX9Tools.Collections.SimpleTextureCollection, ByVal File As String, ByVal Filter As Direct3D.Filter, ByVal ColorKey As Color) As Integer
    '    Dim Tex As Direct3D.Texture

    '    Tex = Direct3D.TextureLoader.FromFile(Device, File, 0, 0, 0, 0, _
    '                                               Direct3D.Format.Unknown, Direct3D.Pool.Managed, _
    '                                               Filter, Filter, _
    '                                               Color.Black.ToArgb)
    '    Return TextureCollection.Add(Tex)
    'End Function

    'Public Function LoadTexture(ByVal Device As Direct3D.Device, ByVal TextureCollection As DX9Tools.Collections.SimpleTextureCollection, ByVal File As String, ByRef Info As Direct3D.ImageInformation) As Integer
    '    Dim Tex As Direct3D.Texture

    '    Tex = Direct3D.TextureLoader.FromFile(Device, File, 0, 0, 0, 0, _
    '                                                Direct3D.Format.Unknown, Direct3D.Pool.Managed, _
    '                                                Direct3D.Filter.None, Direct3D.Filter.None, _
    '                                                Color.Black.ToArgb)
    '    Info = Direct3D.TextureLoader.ImageInformationFromFile(File)
    '    Return TextureCollection.Add(Tex)
    'End Function

    'Public Function LoadTexture(ByVal Device As Direct3D.Device, ByVal TextureCollection As DX9Tools.Collections.SimpleTextureCollection, ByVal File As String, ByVal ColorKey As Color, ByRef Info As Direct3D.ImageInformation) As Integer
    '    Dim Tex As Direct3D.Texture

    '    Tex = Direct3D.TextureLoader.FromFile(Device, File, 0, 0, 0, 0, _
    '                                                Direct3D.Format.Unknown, Direct3D.Pool.Managed, _
    '                                                Direct3D.Filter.None, Direct3D.Filter.None, _
    '                                                ColorKey.ToArgb)
    '    Info = Direct3D.TextureLoader.ImageInformationFromFile(File)
    '    Return TextureCollection.Add(Tex)
    'End Function

    'Public Function LoadTexture(ByVal Device As Direct3D.Device, ByVal TextureCollection As DX9Tools.Collections.SimpleTextureCollection, ByVal File As String, ByVal Filter As Direct3D.Filter, ByRef Info As Direct3D.ImageInformation) As Integer
    '    Dim Tex As Direct3D.Texture

    '    Tex = Direct3D.TextureLoader.FromFile(Device, File, 0, 0, 0, 0, _
    '                                                  Direct3D.Format.Unknown, Direct3D.Pool.Managed, _
    '                                                  Filter, Filter, _
    '                                                  Color.Black.ToArgb)
    '    Info = Direct3D.TextureLoader.ImageInformationFromFile(File)
    '    Return TextureCollection.Add(Tex)
    'End Function

    'Public Function LoadTexture(ByVal Device As Direct3D.Device, ByVal TextureCollection As DX9Tools.Collections.SimpleTextureCollection, ByVal File As String, ByVal Filter As Direct3D.Filter, ByVal ColorKey As Color, ByRef Info As Direct3D.ImageInformation) As Integer
    '    Dim Tex As Direct3D.Texture

    '    Tex = Direct3D.TextureLoader.FromFile(Device, File, 0, 0, 0, 0, _
    '                                                 Direct3D.Format.Unknown, Direct3D.Pool.Managed, _
    '                                                 Filter, Filter, _
    '                                                 Color.Black.ToArgb)
    '    Info = Direct3D.TextureLoader.ImageInformationFromFile(File)
    '    Return TextureCollection.Add(Tex)
    'End Function


    '#Region " CaptureScreenshot ... "
    '    ''' <summary>
    '    ''' Captures a screen shot.
    '    ''' </summary>
    '    ''' <param name="Device">The revice to capture the screen shot from.</param>
    '    ''' <param name="Filename">The filename to save the image file to.</param>
    '    ''' <param name="ImageFormat">The file format to save the image as.</param>
    '    ''' <returns>If the screen capture was successfull then CaptureScreenshot will return True.</returns>
    '    ''' <remarks>
    '    ''' This method will save a screen shot using the specified image format from the ImageFormat parameter regardless 
    '    ''' of what filename extention is specified in the Filename parameter.
    '    ''' Note that the CaptureScreenshot method saves the contents of the devices backbuffer, so make sure you don't
    '    ''' do a clear before capturing a screen shot.
    '    ''' </remarks>
    '    Public Shared Function CaptureScreenshot(ByVal Device As Direct3D.Device, ByVal Filename As String, ByVal ImageFormat As Direct3D.ImageFileFormat) As Boolean
    '        Dim B As Direct3D.Surface

    '        Try
    '            ' get back buffer
    '            B = Device.GetBackBuffer(0, 0, DirectX.Direct3D.BackBufferType.Mono)

    '            ' save capture image
    '            Direct3D.SurfaceLoader.Save(Filename, ImageFormat, B)
    '            B.Dispose()
    '        Catch ex As Exception
    '            Return False
    '        End Try

    '        Return True
    '    End Function

    '    ''' <summary>
    '    ''' Captures a screen shot.
    '    ''' </summary>
    '    ''' <param name="Device">The revice to capture the screen shot from.</param>
    '    ''' <param name="Filename">The filename to save the image file to.</param>
    '    ''' <param name="ImageFormat">The file format to save the image as.</param>
    '    ''' <returns>If the screen capture was successfull then CaptureScreenshot will return True.</returns>
    '    ''' <remarks>
    '    ''' Since no image format is specified CaptureScreenshot will try to save the image using the *.bmp format.
    '    ''' Regardless of what filename extention is specified in the Filename parameter.
    '    ''' Note that the CaptureScreenshot method saves the contents of the devices backbuffer, so make sure you don't
    '    ''' do a clear before capturing a screen shot.
    '    ''' </remarks>
    '    Public Shared Function CaptureScreenshot(ByVal Device As Direct3D.Device, ByVal Filename As String) As Boolean
    '        Return CaptureScreenshot(Device, Filename, Direct3D.ImageFileFormat.Bmp)
    '    End Function
    '#End Region

#Region " CreateViewport overloads ... "
    'TODO: add more CreateViewport overloads ...

    ''' <summary>
    ''' Creates a Direct3D.Viewport type using the specified arguments.
    ''' </summary>
    ''' <param name="X"></param>
    ''' <param name="Y"></param>
    ''' <param name="Width"></param>
    ''' <param name="Height"></param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    ''' <returns>Returns a Direct3D.Viewport type.</returns>
    Public Function CreateViewport(ByVal X As Integer, ByVal Y As Integer, ByVal Width As Integer, ByVal Height As Integer, _
             ByVal MinZ As Single, ByVal MaxZ As Single) As Direct3D.Viewport

        Dim VP As New Direct3D.Viewport()
        VP.X = X
        VP.Y = Y
        VP.Width = Width
        VP.Height = Height
        VP.MinZ = MinZ
        VP.MaxZ = MaxZ
        Return VP
    End Function

    ''' <summary>
    ''' Creates the view using the provided Rectangle type.
    ''' </summary>
    ''' <param name="R">The dimentions of the view.</param>
    Public Function CreateViewport(ByVal R As Rectangle) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = R.X
            .Y = R.Y
            .Width = R.Width
            .Height = R.Height
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided Rectangle type.
    ''' </summary>
    ''' <param name="R">The dimentions of the view.</param>
    Public Function CreateViewport(ByVal R As RectangleF) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(R.X)
            .Y = Convert.ToInt32(R.Y)
            .Width = Convert.ToInt32(R.Width)
            .Height = Convert.ToInt32(R.Height)
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    Public Function CreateViewport(ByVal P As Point, ByVal S As Size) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = P.X
            .Y = P.Y
            .Width = S.Width
            .Height = S.Height
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    Public Function CreateViewport(ByVal P As PointF, ByVal S As Size) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .Width = S.Width
            .Height = S.Height
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    Public Function CreateViewport(ByVal P As PointF, ByVal S As SizeF) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .Width = Convert.ToInt32(S.Width)
            .Height = Convert.ToInt32(S.Height)
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    Public Function CreateViewport(ByVal P As Point, ByVal S As SizeF) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = P.X
            .Y = P.Y
            .Width = Convert.ToInt32(S.Width)
            .Height = Convert.ToInt32(S.Height)
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the top left of the view.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    Public Function CreateViewport(ByVal P As Point) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = P.X
            .Y = P.Y
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the top left of the view.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    Public Function CreateViewport(ByVal P As PointF) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the width and height of the view.
    ''' </summary>
    ''' <param name="S">The width and height of the view.</param>
    Public Function CreateViewport(ByVal S As Size) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .Width = S.Width
            .Height = S.Height
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the width and height of the view.
    ''' </summary>
    ''' <param name="S">The width and height of the view.</param>
    Public Function CreateViewport(ByVal S As SizeF) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .Width = Convert.ToInt32(S.Width)
            .Height = Convert.ToInt32(S.Height)
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the top left of the view.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    Public Function CreateViewport(ByVal P As Vector2) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the top left of the view.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    Public Function CreateViewport(ByVal P As Vector3) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    Public Function CreateViewport(ByVal P As Vector2, ByVal S As Size) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .Width = S.Width
            .Height = S.Height
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    Public Function CreateViewport(ByVal P As Vector3, ByVal S As Size) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .Width = S.Width
            .Height = S.Height
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    Public Function CreateViewport(ByVal P As Vector2, ByVal S As SizeF) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .Width = Convert.ToInt32(S.Width)
            .Height = Convert.ToInt32(S.Height)
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    Public Function CreateViewport(ByVal P As Vector3, ByVal S As SizeF) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .Width = Convert.ToInt32(S.Width)
            .Height = Convert.ToInt32(S.Height)
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided Rectangle and Min/Max z Depth.
    ''' </summary>
    ''' <param name="R">The dimentions of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal R As Rectangle, ByVal MinZ As Single, ByVal MaxZ As Single) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = R.X
            .Y = R.Y
            .Width = R.Width
            .Height = R.Height
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided Rectangle and Min/Max z Depth.
    ''' </summary>
    ''' <param name="R">The dimentions of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal R As RectangleF, ByVal MinZ As Single, ByVal MaxZ As Single) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(R.X)
            .Y = Convert.ToInt32(R.Y)
            .Width = Convert.ToInt32(R.Width)
            .Height = Convert.ToInt32(R.Height)
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As Point, ByVal S As Size, ByVal MinZ As Single, ByVal MaxZ As Single) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = P.X
            .Y = P.Y
            .Width = S.Width
            .Height = S.Height
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As PointF, ByVal S As Size, ByVal MinZ As Single, ByVal MaxZ As Single) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .Width = S.Width
            .Height = S.Height
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As PointF, ByVal S As SizeF, ByVal MinZ As Single, ByVal MaxZ As Single) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .Width = Convert.ToInt32(S.Width)
            .Height = Convert.ToInt32(S.Height)
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As Point, ByVal S As SizeF, ByVal MinZ As Single, ByVal MaxZ As Single) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = P.X
            .Y = P.Y
            .Width = Convert.ToInt32(S.Width)
            .Height = Convert.ToInt32(S.Height)
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As Point, ByVal MinZ As Single, ByVal MaxZ As Single) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = P.X
            .Y = P.Y
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As PointF, ByVal MinZ As Single, ByVal MaxZ As Single) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided size and Min/Max z Depth.
    ''' </summary>
    ''' <param name="S">The width and height of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal S As Size, ByVal MinZ As Single, ByVal MaxZ As Single) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .Width = S.Width
            .Height = S.Height
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided size and Min/Max z Depth.
    ''' </summary>
    ''' <param name="S">The width and height of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal S As SizeF, ByVal MinZ As Single, ByVal MaxZ As Single) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .Width = Convert.ToInt32(S.Width)
            .Height = Convert.ToInt32(S.Height)
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As Vector2, ByVal MinZ As Single, ByVal MaxZ As Single) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As Vector3, ByVal MinZ As Single, ByVal MaxZ As Single) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As Vector2, ByVal S As Size, ByVal MinZ As Single, ByVal MaxZ As Single) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .Width = S.Width
            .Height = S.Height
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As Vector3, ByVal S As Size, ByVal MinZ As Single, ByVal MaxZ As Single) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .Width = S.Width
            .Height = S.Height
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As Vector2, ByVal S As SizeF, ByVal MinZ As Single, ByVal MaxZ As Single) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .Width = Convert.ToInt32(S.Width)
            .Height = Convert.ToInt32(S.Height)
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As Vector3, ByVal S As SizeF, ByVal MinZ As Single, ByVal MaxZ As Single) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .Width = Convert.ToInt32(S.Width)
            .Height = Convert.ToInt32(S.Height)
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided Rectangle and Min/Max z Depth.
    ''' </summary>
    ''' <param name="R">The dimentions of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal R As Rectangle, ByVal MinZ As Integer, ByVal MaxZ As Integer) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = R.X
            .Y = R.Y
            .Width = R.Width
            .Height = R.Height
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided Rectangle and Min/Max z Depth.
    ''' </summary>
    ''' <param name="R">The dimentions of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal R As RectangleF, ByVal MinZ As Integer, ByVal MaxZ As Integer) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(R.X)
            .Y = Convert.ToInt32(R.Y)
            .Width = Convert.ToInt32(R.Width)
            .Height = Convert.ToInt32(R.Height)
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As Point, ByVal S As Size, ByVal MinZ As Integer, ByVal MaxZ As Integer) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = P.X
            .Y = P.Y
            .Width = S.Width
            .Height = S.Height
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As PointF, ByVal S As Size, ByVal MinZ As Integer, ByVal MaxZ As Integer) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .Width = S.Width
            .Height = S.Height
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As PointF, ByVal S As SizeF, ByVal MinZ As Integer, ByVal MaxZ As Integer) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .Width = Convert.ToInt32(S.Width)
            .Height = Convert.ToInt32(S.Height)
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As Point, ByVal S As SizeF, ByVal MinZ As Integer, ByVal MaxZ As Integer) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = P.X
            .Y = P.Y
            .Width = Convert.ToInt32(S.Width)
            .Height = Convert.ToInt32(S.Height)
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As Point, ByVal MinZ As Integer, ByVal MaxZ As Integer) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = P.X
            .Y = P.Y
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    '''      ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As PointF, ByVal MinZ As Integer, ByVal MaxZ As Integer) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided size and Min/Max z Depth.
    ''' </summary>
    ''' <param name="S">The width and height of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal S As Size, ByVal MinZ As Integer, ByVal MaxZ As Integer) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .Width = S.Width
            .Height = S.Height
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided size and Min/Max z Depth.
    ''' </summary>
    ''' <param name="S">The width and height of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal S As SizeF, ByVal MinZ As Integer, ByVal MaxZ As Integer) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .Width = Convert.ToInt32(S.Width)
            .Height = Convert.ToInt32(S.Height)
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As Vector2, ByVal MinZ As Integer, ByVal MaxZ As Integer) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As Vector3, ByVal MinZ As Integer, ByVal MaxZ As Integer) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As Vector2, ByVal S As Size, ByVal MinZ As Integer, ByVal MaxZ As Integer) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .Width = S.Width
            .Height = S.Height
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As Vector3, ByVal S As Size, ByVal MinZ As Integer, ByVal MaxZ As Integer) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .Width = S.Width
            .Height = S.Height
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As Vector2, ByVal S As SizeF, ByVal MinZ As Integer, ByVal MaxZ As Integer) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .Width = Convert.ToInt32(S.Width)
            .Height = Convert.ToInt32(S.Height)
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided location and size and Min/Max z Depth.
    ''' </summary>
    ''' <param name="P">The top left of the view.</param>
    ''' <param name="S">The width and height of the view.</param>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal P As Vector3, ByVal S As SizeF, ByVal MinZ As Integer, ByVal MaxZ As Integer) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .X = Convert.ToInt32(P.X)
            .Y = Convert.ToInt32(P.Y)
            .Width = Convert.ToInt32(S.Width)
            .Height = Convert.ToInt32(S.Height)
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided Min/Max z Depth.
    ''' </summary>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal MinZ As Single, ByVal MaxZ As Single) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function

    ''' <summary>
    ''' Creates the view using the provided Min/Max z Depth.
    ''' </summary>
    ''' <param name="MinZ">Value describing, together with MaxZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 0.0. Clipping is performed after applying the projection matrix.</param>
    ''' <param name="MaxZ">Value describing, together with MinZ, the range of depth values into which a scene is to be rendered, the minimum and maximum values of the clip volume. Most applications set this value to 1.0. Clipping is performed after applying the projection matrix.</param>
    Public Function CreateViewport(ByVal MinZ As Integer, ByVal MaxZ As Integer) As Direct3D.Viewport
        Dim mobjViewport As Direct3D.Viewport

        With mobjViewport
            .MinZ = MinZ
            .MaxZ = MaxZ
        End With

        Return mobjViewport
    End Function
#End Region

    Public Function ColorChannelBits(ByVal fmt As Direct3D.Format) As Integer
        Select Case fmt
            Case Direct3D.Format.R8G8B8
                Return 8

            Case Direct3D.Format.A8R8G8B8
                Return 8

            Case Direct3D.Format.X8R8G8B8
                Return 8

            Case Direct3D.Format.R5G6B5
                Return 5

            Case Direct3D.Format.X1R5G5B5
                Return 5

            Case Direct3D.Format.A1R5G5B5
                Return 5

            Case Direct3D.Format.A4R4G4B4
                Return 4

            Case Direct3D.Format.R3G3B2
                Return 2

            Case Direct3D.Format.A8R3G3B2
                Return 2

            Case Direct3D.Format.X4R4G4B4
                Return 4

            Case Direct3D.Format.A2B10G10R10
                Return 10

            Case Direct3D.Format.A2R10G10B10
                Return 10

            Case Else
                Return 0
        End Select
    End Function

    Public Function AlphaChannelBits(ByVal fmt As Direct3D.Format) As Integer
        Select Case fmt
            Case Direct3D.Format.R8G8B8
                Return 0

            Case Direct3D.Format.A8R8G8B8
                Return 8

            Case Direct3D.Format.X8R8G8B8
                Return 0

            Case Direct3D.Format.R5G6B5
                Return 0

            Case Direct3D.Format.X1R5G5B5
                Return 0

            Case Direct3D.Format.A1R5G5B5
                Return 1

            Case Direct3D.Format.A4R4G4B4
                Return 4

            Case Direct3D.Format.R3G3B2
                Return 0

            Case Direct3D.Format.A8R3G3B2
                Return 8

            Case Direct3D.Format.X4R4G4B4
                Return 0

            Case Direct3D.Format.A2B10G10R10
                Return 2

            Case Direct3D.Format.A2R10G10B10
                Return 2

            Case Else
                Return 0
        End Select
    End Function

    Public Function DepthBits(ByVal fmt As Direct3D.DepthFormat) As Integer
        Select Case fmt
            Case Direct3D.DepthFormat.D16
                Return 16

            Case Direct3D.DepthFormat.D15S1
                Return 15

            Case Direct3D.DepthFormat.D24X8
                Return 24

            Case Direct3D.DepthFormat.D24S8
                Return 24

            Case Direct3D.DepthFormat.D24X4S4
                Return 24

            Case Direct3D.DepthFormat.D32
                Return 32

            Case Else
                Return 0
        End Select
    End Function

    Public Function StencilBits(ByVal fmt As Direct3D.DepthFormat) As Integer
        Select Case fmt
            Case Direct3D.DepthFormat.D16
                Return 0

            Case Direct3D.DepthFormat.D15S1
                Return 1

            Case Direct3D.DepthFormat.D24X8
                Return 0

            Case Direct3D.DepthFormat.D24S8
                Return 8

            Case Direct3D.DepthFormat.D24X4S4
                Return 4

            Case Direct3D.DepthFormat.D32
                Return 0

            Case Else
                Return 0
        End Select
    End Function
End Module
