'Created by: X
'Copyright: Created by: X
'Web: http://www.createdbyx.com/
'Date: Wednesday, April 27, 2005
'=============================================

Public Class TimeController
    Protected Friend mlngCurrentTime As Long
    Protected Friend msngTimeStep As Single = 1
    Protected Friend mlngLastTime As Long


    Public Sub Update(ByVal Time As Long)
        If Time > mlngLastTime Then
            Try                       ' if overflow exception thrown set to max value
                CurrentTime += CLng((Time - mlngLastTime) * TimeStep)
            Catch ofex As OverflowException
                CurrentTime = CurrentTime.MaxValue
            End Try
            mlngLastTime = Time
        End If
    End Sub

    Public Property CurrentTime() As Long
        Get
            Return mlngCurrentTime
        End Get
        Set(ByVal Value As Long)
            mlngCurrentTime = Value
        End Set
    End Property

    Public Property TimeStep() As Single
        Get
            Return msngTimeStep
        End Get
        Set(ByVal Value As Single)
            msngTimeStep = Value
        End Set
    End Property

    Public Property LastTime() As Long
        Get
            Return mlngLastTime
        End Get
        Set(ByVal Value As Long)
            mlngLastTime = Value
        End Set
    End Property
End Class